Package: DiffLogo
Type: Package
Title: DiffLogo: A comparative visualisation of biooligomer motifs
Version: 2.35.0
Date: 2015-02-12
Author: c( 
    person("Martin", "Nettling", role = c("aut", "cre"), email = "martin.nettling@informatik.uni-halle.de"), 
    person("Hendrik", "Treutler", role = c("aut", "cre"), email = "hendrik.treutler@ipb-halle.de"),
    person("Jan", "Grau", role = c("aut", "ctb"), email = "grau@informatik.uni-halle.de"), 
    person("Andrey", "Lando", role = c("aut", "ctb"), email = "dronte@autosome.ru"), 
    person("Jens", "Keilwagen", role = c("aut", "ctb"), email = "jens.keilwagen@julius-kuehn.de"), 
    person("Stefan", "Posch", role = "aut", email = "posch@informatik.uni-halle.de"), 
    person("Ivo", "Grosse", role = "aut", email = "grosse@informatik.uni-halle.de"))
Depends: R (>= 3.4), stats, cba
Imports: grDevices, graphics, utils, tools
Suggests: knitr, testthat, seqLogo, MotifDb
Maintainer: Hendrik Treutler<hendrik.treutler@gmail.com>
Description: DiffLogo is an easy-to-use tool to visualize motif differences.
License: GPL (>= 2)
URL: https://github.com/mgledi/DiffLogo/
BugReports: https://github.com/mgledi/DiffLogo/issues
biocViews: Software, SequenceMatching, MultipleComparison,
        MotifAnnotation, Visualization, Alignment
Collate: 'alphabet.R' 'baseDistrs.R' 'diffSeqLogo.R' 'preconditions.R'
        'seqLogo.R' 'stackHeights.R' 'utilities.R'
        'diffSeqLogoSupport.R' 'pwmAlignment.R'
RoxygenNote: 6.1.1
git_url: https://git.bioconductor.org/packages/DiffLogo
git_branch: devel
git_last_commit: 933892e
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 20:55:20 UTC; biocbuild

preconditionPWM = function(pwm) {
  if (any(abs(1 - apply(pwm, 2, sum)) > 0.01)) { # check if the sum of each columns is near 1
    stop("Columns of PWM must add up to 1.0")
  }
}
preconditionProbabilityVector = function(vec) {
  if (abs(1 - sum(vec)) > 0.01) { # check if the sum of each columns is near 1
    stop("Vector must add up to 1.0")
  }
}

preconditionTransformPWM = function(pwm, alphabet) {
    if (is(pwm, "pwm")) {
        return (pwm@pwm)
    } else if (is(pwm, "data.frame")) {
        return (as.matrix(pwm))
    } else if (is(pwm, "matrix")) {
        print("pwm must be of class matrix or data.frame. Trying to convert")
        return (matrix(pwm,alphabet$size,length(pwm)/alphabet$size))
    }
    return(pwm)
}

preconditionPWMSameSize = function(pwm1, pwm2) {
  if(ncol(pwm1) != ncol(pwm2) || nrow(pwm1) != nrow(pwm2)) {  # check if the two PWMs have the same length
    stop("The two given PWMs must have the same dimension");
  }
}
preconditionVectorSameSize = function(vec1, vec2) {
  if(length(vec1) != length(vec2)) {  # check if the two vectors have the same length
    stop("The two given vectors must have the same length");
  }
}

preconditionStackHeight = function(h) {
    if(is.na(h$height)) {
        stop("Height is not allowed to be NA.");
    }
}

preconditionBaseDistribution = function(distr) {
    if(any(is.na(distr))) {
        stop("A value in the given distribution is NA.");
    }
}

### R code from vignette source 'DiffLogoBasics.Rnw'

###################################################
### code chunk number 1: ImportLibrary
###################################################
library(DiffLogo)


###################################################
### code chunk number 2: ImportMotifsFromMotifDb
###################################################
library(MotifDb)

## import motifs
hitIndeces = grep ('CTCF', values (MotifDb)$geneSymbol, ignore.case=TRUE)
list    = as.list(MotifDb[hitIndeces])
sequenceCounts = as.numeric(values (MotifDb)$sequenceCount[hitIndeces])
names(sequenceCounts) = names(list)

pwm1 = reverseComplement(list$"Hsapiens-JASPAR_CORE-CTCF-MA0139.1"[, 2:18]) ## trim and reverse complement
pwm2 = list$"Hsapiens-jolma2013-CTCF"
n1 = sequenceCounts["Hsapiens-JASPAR_CORE-CTCF-MA0139.1"]
n2 = sequenceCounts["Hsapiens-jolma2013-CTCF"]

## DiffLogo can also handle motifs of different length
pwm_long = reverseComplement(list$"Hsapiens-JASPAR_CORE-CTCF-MA0139.1") ## reverse complement
pwm_short = list$"Hsapiens-jolma2013-CTCF"


###################################################
### code chunk number 3: ImportMotifsFromDiffLogoPackage
###################################################
## import five DNA motifs from matrix
motif_folder = "extdata/pwm"
motif_names_dna = c("H1-hESC", "MCF7", "HeLa-S3", "HepG2", "HUVEC")
motifs_dna = list()
for (name in motif_names_dna) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs_dna[[name]] = getPwmFromPwmFile(file)
}
sampleSizes_dna = c("H1-hESC"=100, "MCF7"=100, "HeLa-S3"=100, "HepG2"=100, "HUVEC"=100)
## import three DNA motifs from table
motif_folder = "extdata/alignments"
motif_names_dna2 = c("Mad", "Max", "Myc")
motifs_dna2 = list()
for (name in motif_names_dna2) {
  fileName = paste(motif_folder,"/",name,".txt",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs_dna2[[name]] = getPwmFromAlignmentFile(file)
}
## import three ASN motifs from fasta files
motif_folder = "extdata/alignments"
motif_names_asn = c("F-box_fungi.seq", "F-box_metazoa.seq", "F-box_viridiplantae.seq")
motifs_asn = list()
for (name in motif_names_asn) {
  fileName = paste(motif_folder,"/",name,".fa",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs_asn[[name]] = getPwmFromFastaFile(file, FULL_ALPHABET)
}


###################################################
### code chunk number 4: PlotSequenceLogo
###################################################
## plot classic sequence logo
library(seqLogo)
seqLogo::seqLogo(pwm = pwm1)


###################################################
### code chunk number 5: PlotCustomSequenceLogo
###################################################
## plot custom sequence logo
par(mfrow=c(2,1), pin=c(3, 1), mar = c(2, 4, 1, 1))
DiffLogo::seqLogo(pwm = pwm1)
DiffLogo::seqLogo(pwm = pwm2, stackHeight = sumProbabilities)
par(mfrow=c(1,1), pin=c(1, 1), mar=c(5.1, 4.1, 4.1, 2.1))


###################################################
### code chunk number 6: PlotDiffLogo
###################################################
## plot DiffLogo
diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2)

## diffLogoFromPwm is a convenience function for
diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
diffLogo(diffLogoObj)

## mark symbol stacks with significant changes
diffLogoObj = enrichDiffLogoObjectWithPvalues(diffLogoObj, n1, n2)
diffLogo(diffLogoObj)

## plot DiffLogo for PWMs of different length
diffLogoFromPwm(pwm1 = pwm_long, pwm2 = pwm_short, align_pwms=TRUE)


###################################################
### code chunk number 7: PlotDiffLogoTable
###################################################
## plot table of difference logos for CTFC motifs (DNA)
diffLogoTable(PWMs = motifs_dna)
## plot table of difference logos for E-Box motifs (DNA)
diffLogoTable(PWMs = motifs_dna2)
## plot table of difference logos for F-Box motifs (ASN)
diffLogoTable(PWMs = motifs_asn, alphabet = FULL_ALPHABET)
## CTFC motifs (DNA) with asterisks to indicate significant differences
diffLogoTable(PWMs = motifs_dna, sampleSizes = sampleSizes_dna)


###################################################
### code chunk number 8: Export
###################################################
## parameters
widthToHeightRatio = 16/10;
size = length(motifs_dna) * 2
resolution = 300
width = size * widthToHeightRatio
height = size

## export single DiffLogo as pdf document
fileName = "Comparison_of_two_motifs.pdf"
pdf(file = fileName, width = width, height = height)
diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2)
dev.off()

## export DiffLogo table as png image
fileName = "Comparison_of_multiple_motifs.png"
png(
  filename = fileName, res = resolution,
  width = width * resolution, height = height * resolution)
diffLogoTable(PWMs = motifs_dna)
dev.off()


###################################################
### code chunk number 9: Alignment
###################################################
## align pwms and than plot seqLogo of them
pwms = list(pwm_long, pwm_short)
multiple_pwms_alignment = multipleLocalPwmsAlignment(pwms)
aligned_pwms = extendPwmsFromAlignmentVector(pwms, multiple_pwms_alignment$alignment$vector)

## seqLogo of aligned pwms
layout(mat = matrix(data = 1:4, nrow = 2, ncol = 2))
DiffLogo::seqLogo(pwms[[1]], main = "Unaligned")
DiffLogo::seqLogo(pwms[[2]])
DiffLogo::seqLogo(aligned_pwms[[1]], main = "Aligned")
DiffLogo::seqLogo(aligned_pwms[[2]])

divergencePenaltyForUnaligned = function(pwm, unaligned_at_left,
                                         aligned_length,
                                         unaligned_at_right, divergence,
                                         base_distribution) {
    shift_divergence = 0
    if (unaligned_at_left > 0) {
       shift_divergence = shift_divergence +
                          pwmDivergence(    matrix( pwm[,1:unaligned_at_left], nrow=nrow(pwm)),
                                            baseDistributionPwm( unaligned_at_left, nrow(pwm), base_distribution = base_distribution), 
                                            divergence
                                        );
    }
    if (unaligned_at_right > 0) {
       aligned_length = ncol(pwm) - unaligned_at_right
       shift_divergence = shift_divergence +
                          pwmDivergence(    matrix(pwm[,(aligned_length+1):ncol(pwm)], nrow=nrow(pwm)), 
                                            baseDistributionPwm(ncol(pwm)-aligned_length, nrow(pwm), base_distribution = base_distribution), 
                                            divergence
                                        );
    }
    return(shift_divergence)
}

findBestShiftForPwms = function(static_pwm, shifted_pwm, divergence,  unaligned_penalty, base_distribution, length_normalization) {
    best_divergence = Inf
    best_shift = 0
    for (shift in 0:(ncol(static_pwm)-1)){
        intersection_length = min(ncol(static_pwm) - shift, ncol(shifted_pwm))
        shift_divergence = pwmDivergence(
                                matrix( static_pwm[, (shift+1):(shift+intersection_length)], nrow=nrow(static_pwm)),
                                matrix( shifted_pwm[,1:intersection_length], nrow=nrow(shifted_pwm)),
                                divergence=divergence)
        shift_divergence = shift_divergence+unaligned_penalty(
                                      static_pwm,
                                      unaligned_at_left = shift,
                                      intersection_length,
                                      unaligned_at_right = max(0, ncol(static_pwm) - (shift+intersection_length)),
                                      divergence,
                                      base_distribution);
        shift_divergence = shift_divergence+unaligned_penalty(
                                      shifted_pwm,
                                      unaligned_at_left = 0,
                                      intersection_length,
                                      unaligned_at_right = max(0, ncol(shifted_pwm) - intersection_length),
                                      divergence,
                                      base_distribution);
        if (length_normalization) {
           shift_divergence = shift_divergence / max(ncol(static_pwm), shift + ncol(shifted_pwm));
        }
        if (shift_divergence < best_divergence) {
           best_divergence = shift_divergence
           best_shift = shift
        }
    }
    return(list('divergence' = best_divergence, 'shift' = best_shift));
}

##' Finds best local alignment for two PWMs.
##'
##' @title Align pwms
##' @param pwm_left first PWM, a matrix of type matrix
##' @param pwm_right first PWM, a matrix of type matrix
##' @param divergence is a measure of difference between two pwm columns. Smaller is more similar. If you want to use non-uniform background distribution, provide your own function.
##' @param unaligned_penalty distance for unaligned columns at edges of matrixes. See divergencePenaltyForUnaligned as an example for providing your own function
##' @param try_reverse_complement If false the alignment will not be performed on reverse complements. If true, the input pwms should have column order of ACTG/ACGU.
##' @param base_distribution is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @param length_normalization If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.
##' @return list of length two containing the alignment and the divergence
##' @author Lando Andrey
localPwmAlignment = function(pwm_left, pwm_right, divergence=shannonDivergence, unaligned_penalty=divergencePenaltyForUnaligned, try_reverse_complement=TRUE, base_distribution=NULL, length_normalization = FALSE) {
    no_change = list("shift"=0, "direction"="forward")
    result_alignment_vector = list()
    best_divergence = Inf

    alignment = findBestShiftForPwms(pwm_left, pwm_right, divergence=divergence,
                                     unaligned_penalty=unaligned_penalty,
                                     base_distribution,
                                     length_normalization=length_normalization)
    if (alignment$divergence < best_divergence) {
       result_alignment_vector[[1]] = no_change
       result_alignment_vector[[2]] = list("shift" = alignment$shift, "direction"="forward")
       result_divergence = alignment$divergence
       best_divergence = alignment$divergence
    }

    alignment = findBestShiftForPwms(pwm_right, pwm_left, divergence=divergence,
                                     unaligned_penalty=unaligned_penalty,
                                     base_distribution=base_distribution,
                                     length_normalization=length_normalization)
    if (alignment$divergence < best_divergence) {
        result_alignment_vector[[1]] = list("shift" = alignment$shift, "direction"="forward")
        result_alignment_vector[[2]] = no_change
        result_divergence = alignment$divergence
        best_divergence = alignment$divergence
    }
    
    if (try_reverse_complement) {
        alignment = findBestShiftForPwms(pwm_left, revCompPwm(pwm_right),
                                         divergence=divergence,
                                         unaligned_penalty=unaligned_penalty,
                                         base_distribution=base_distribution,
                                         length_normalization=length_normalization)
        if (alignment$divergence < best_divergence) {
            result_alignment_vector[[1]] = no_change
            result_alignment_vector[[2]] = list("shift" = alignment$shift, "direction"="reverse")
            result_divergence = alignment$divergence
            best_divergence = alignment$divergence
        }

        alignment = findBestShiftForPwms(revCompPwm(pwm_right), pwm_left,
                                         divergence=divergence,
                                         unaligned_penalty=unaligned_penalty,
                                         base_distribution=base_distribution,
                                         length_normalization=length_normalization)
        if (alignment$divergence < best_divergence) {
            result_alignment_vector[[1]] = list("shift" = alignment$shift, "direction"="forward")
            result_alignment_vector[[2]] = list("shift" = 0, "direction"="reverse")
            result_divergence = alignment$divergence
            best_divergence = alignment$divergence
        }
    }
    return(list("vector"=result_alignment_vector, "divergence"=result_divergence))
}

addBefore = function (matrix, to_add_length, base_distribution=NULL) {
    return(cbind(baseDistributionPwm(to_add_length, nrow(matrix), base_distribution), matrix))
}

addAfter = function (matrix, to_add_length, base_distribution=NULL) {
    return(cbind( matrix, baseDistributionPwm(to_add_length, nrow(matrix), base_distribution)))
}

##' Extends pwms by adding base_distribution to both sides, so that they keep aligned, but have equal length.
##'
##' @title Extend pwms with respect to alignment
##' @param pwms is a list of matrixes
##' @param alignment_vector is a list of shifts ($shift) and orientations ($direction)
##' @param base_distribution is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @return extended pwms
##' @export
##' @author Lando Andrey
##' @examples 
##' file1 = system.file("extdata/homer/Max.motif",   package = "DiffLogo")
##' file2 = system.file("extdata/homer/c-Myc.motif", package = "DiffLogo")
##' pwm1 = getPwmFromFile(file1)
##' pwm2 = getPwmFromFile(file2)
##' 
##' pwms <- list(pwm1, pwm2)
##' multiple_pwms_alignment = multipleLocalPwmsAlignment(pwms)
##' aligned_pwms = extendPwmsFromAlignmentVector(pwms, multiple_pwms_alignment$alignment$vector)
extendPwmsFromAlignmentVector = function(pwms, alignment_vector, base_distribution=NULL) {
    stopifnot(length(pwms)==length(alignment_vector))
    max_length = 0
    for (i in 1:length(pwms)) {
        if (alignment_vector[[i]]$direction == 'reverse') {
            pwms[[i]] = revCompPwm(pwms[[i]])
        }
        pwms[[i]] = addBefore(pwms[[i]], alignment_vector[[i]]$shift, base_distribution)
        max_length = max(max_length, ncol(pwms[[i]]))
    }
    for (i in 1:length(pwms)) {
        pwms[[i]] = addAfter(pwms[[i]], max_length - ncol(pwms[[i]]), base_distribution)
    }
    return(pwms)
}

##' Computes average pwm divergence from alignment vector for two datasets. This equals to average divergence between all pairs where one pwm comes from left set, and other comes from right
##'
##' @title Average divergence between two sets.
##' @param left_pwms_list is a list of matrixes
##' @param left_pwms_alignment is a list of shifts ($shift) and orientations ($direction)
##' @param right_pwms_list is a list of matrixes
##' @param right_pwms_alignment is a list of shifts ($shift) and orientations ($direction)
##' @param divergence divergence measure.
##' @return float
##' @author Lando Andrey
twoSetsAveragePwmDivergenceFromAlignmentVector = function(left_pwms_list,
                                                          left_pwms_alignment,
                                                          right_pwms_list,
                                                          right_pwms_alignment,
                                                          divergence = shannonDivergence){
    stopifnot(length(left_pwms_list)==length(left_pwms_alignment))
    stopifnot(length(right_pwms_list)==length(right_pwms_alignment))
    pwms_divergences = c()
    for (left_pwm_index in 1:length(left_pwms_list)) {
        for (right_pwm_index in 1:length(right_pwms_list)) {
            stopifnot(!is.null(left_pwms_list[left_pwm_index]))
            stopifnot(!is.null(right_pwms_list[right_pwm_index]))

            stopifnot(!is.null(left_pwms_alignment[left_pwm_index]))
            stopifnot(!is.null(right_pwms_alignment[right_pwm_index]))
            pwms = extendPwmsFromAlignmentVector(c(left_pwms_list[left_pwm_index], right_pwms_list[right_pwm_index]),
                                                 c(left_pwms_alignment[left_pwm_index], right_pwms_alignment[right_pwm_index]))
            pwms_divergences = c(pwms_divergences, pwmDivergence(pwms[[1]], pwms[[2]], divergence = divergence))
        }
    }
    return(mean(pwms_divergences))
}

findBestShiftForPwmSets = function(static_pwms_list, static_pwms_alignment,
                                   shifted_pwms_list, shifted_pwms_alignment,
                                   divergence = shannonDivergence,
                                   unaligned_penalty = divergencePenaltyForUnaligned) {
    stopifnot(length(static_pwms_list)==length(static_pwms_alignment$vector))
    stopifnot(length(shifted_pwms_list)==length(shifted_pwms_alignment$vector))
    best_divergence = Inf
    best_shift = 0
    max_possible_shift = 0
    result = list()
    for (i in 1:length(static_pwms_list)) {
        max_possible_shift = max(max_possible_shift,
                                 ncol(static_pwms_list[[i]])
                                     +static_pwms_alignment$vector[[i]]$shift)
    }
    for (shift in 0:max_possible_shift) {
        divergence_for_shift = twoSetsAveragePwmDivergenceFromAlignmentVector(
            static_pwms_list, static_pwms_alignment$vector,
            shifted_pwms_list, shifted_pwms_alignment$vector,
            divergence=divergence)
        if (divergence_for_shift < best_divergence) {
            best_divergence = divergence_for_shift
            result = list("vector" = c(static_pwms_alignment$vector, shifted_pwms_alignment$vector),
                          "divergence" = best_divergence)
        }
        for (i in 1:length(shifted_pwms_alignment$vector)) {
            shifted_pwms_alignment$vector[[i]]$shift = shifted_pwms_alignment$vector[[i]]$shift+1
        }
    }
    return(result)
}

##' Switches between 'forward' and 'reverse'
##' 
##' @title Switches between 'forward' and 'reverse'
##' @param direction either 'forward' or 'reverse'
##' @return either 'reverse' or 'forward'
switchDirection = function(direction) {
    if (direction=='forward') {
       return('reverse')
    } else if (direction=='reverse') {
       return('forward')
    }
    stopifnot(FALSE);
}

##' Returns alignment vector as if all pwm were reverted.
##'
##' @title Reverse for alignment vector
##' @param alignment_vector list of list which $shift and $orientation
##' @param pwms list of matrixes.
##' @return list - reversed alignment vector
##' @author Lando Andrey
reverseAlignmentVector = function(alignment_vector, pwms) {
    stopifnot(length(alignment_vector)==length(pwms));
    alignment_length = 0;
    for (i in 1:length(alignment_vector)) {
        alignment_vector[[i]]$direction = switchDirection(alignment_vector[[i]]$direction);
        stopifnot(alignment_vector[[i]]$shift >= 0);
        alignment_length = max(alignment_length, ncol(pwms[[i]]) + alignment_vector[[i]]$shift);
    }
    min_shift = 0;
    for (i in 1:length(alignment_vector)) {
        alignment_vector[[i]]$shift = alignment_length - ncol(pwms[[i]]) - alignment_vector[[i]]$shift;
        min_shift = min(min_shift, alignment_vector[[i]]$shift);
    }
    for (i in 1:length(alignment_vector)) {
        alignment_vector[[i]]$shift = -min_shift + alignment_vector[[i]]$shift;
    }
    return(alignment_vector)
}


##' Align two sets of pwms
##'
##' @title Multiple PWMs alignment
##' @param left_pwms_set list of pwms(matrixes)
##' @param left_alignment alignment of left_pwms_set. 
##' @param right_pwms_set list of pwms;
##' @param right_alignment alignment of right_pwms_set.
##' @param try_reverse_complement if true(default), also try reverse complement.
##' @return list - alignment of concatination of left_pwms_set and right_pwms_set
##' @author Lando Andrey
alignPwmSets = function(left_pwms_set, left_alignment, right_pwms_set, right_alignment, try_reverse_complement) {
    stopifnot(length(left_pwms_set)==length(left_alignment$vector))
    stopifnot(length(right_pwms_set)==length(right_alignment$vector))
    result = list()
    best_divergence = Inf
    alignment = findBestShiftForPwmSets(left_pwms_set, left_alignment, right_pwms_set, right_alignment)
    if (alignment$divergence < best_divergence) {
       result = alignment
       best_divergence = alignment$divergence
    }

    alignment = findBestShiftForPwmSets(right_pwms_set, right_alignment, left_pwms_set, left_alignment)
    if (alignment$divergence < best_divergence) {
       best_divergence = alignment$divergence
       result$vector = c(alignment$vector[(length(right_pwms_set)+1):(length(alignment$vector))],
                            alignment$vector[1:length(right_pwms_set)])
       result$divergence = best_divergence
    }

    if(try_reverse_complement) {
      right_alignment$vector = reverseAlignmentVector(right_alignment$vector, right_pwms_set)
      alignment = findBestShiftForPwmSets(left_pwms_set, left_alignment, right_pwms_set, right_alignment)
      if (alignment$divergence < best_divergence) {
         result = alignment
         best_divergence = alignment$divergence
      }
    }

    alignment = findBestShiftForPwmSets(right_pwms_set, right_alignment, left_pwms_set, left_alignment)
    if (alignment$divergence < best_divergence) {
       best_divergence = alignment$divergence
       result$vector = c(alignment$vector[(length(right_pwms_set)+1):(length(alignment$vector))], alignment$vector[1:length(right_pwms_set)])
       result$divergence = best_divergence
    }
    return(result)
}

##' Creates a distance matrix for pwms
##'
##' @title Multiple PWMs alignment
##' @param pwms list of pwms
##' @param diagonal_value value to put on diagonal.
##' @param bottom_default_value value to put on bottom triangle. Set to NULL to get symmetric distance matrix.
##' @param divergence divergence measure.
##' @param unaligned_penalty is a function for localPwmAlignment.
##' @param try_reverse_complement if True, alignment will try reverse complement pwms
##' @param base_distribution is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @param length_normalization is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @return list
##' @author Lando Andrey
pwmsDistanceMatrix = function(pwms,
                              diagonal_value = 0,
                              bottom_default_value = NULL,
                              divergence=shannonDivergence,
                              unaligned_penalty=divergencePenaltyForUnaligned,
                              try_reverse_complement=TRUE, base_distribution=NULL,
                              length_normalization = FALSE){
    distance_matrix = matrix(0, ncol=length(pwms), nrow=length(pwms))
    for (i in 1:(length(pwms)-1)) {
        distance_matrix[[i, i]] = diagonal_value
        for (j in (i+1):length(pwms)) {
            distance_matrix[[i, j]] = localPwmAlignment(
                pwms[[i]], pwms[[j]],
                divergence=divergence,
                unaligned_penalty=unaligned_penalty,
                try_reverse_complement=try_reverse_complement,
                base_distribution=base_distribution,
                length_normalization = length_normalization)$divergence
            if (is.null(bottom_default_value)) {
                distance_matrix[[j, i]] = distance_matrix[[i, j]]
            } else {
                distance_matrix[[j, i]] = bottom_default_value
            }
        }
    }
    distance_matrix[[length(pwms), length(pwms)]] = diagonal_value
    return(distance_matrix)
}

minimumMatrixElementIndexes = function(matrix) {
    minimum_element = which.min(matrix)
    col_of_minimum = round(minimum_element/ncol(matrix)-0.5)+1
    row_of_minimum = minimum_element - ((col_of_minimum-1) * (ncol(matrix)))
    first_index = min(col_of_minimum, row_of_minimum)
    second_index = max(col_of_minimum, row_of_minimum)
    return(list(first_index, second_index))
}

addLastTreeNodeToDistanceMatrix = function(distance_matrix, tree_nodes, try_reverse_complement) {
    distance_matrix = cbind(distance_matrix, rep(Inf, ncol(distance_matrix)))
    distance_matrix = rbind(distance_matrix, rep(Inf, ncol(distance_matrix)))
    last = ncol(distance_matrix)
    if (last > 0) {
        for (i in 1:(last-1)) {
            distance_matrix[[i, last]] = alignPwmSets( tree_nodes[[last]]$pwms, tree_nodes[[last]]$pwms_alignment,
                tree_nodes[[i]]$pwms,tree_nodes[[i]]$pwms_alignment, try_reverse_complement)$divergence
        }
    }
    return(distance_matrix)
}

joinTwoNodesInAlignmentTree = function(distance_matrix, tree_nodes, join_counter, try_reverse_complement) {
    min_pwm_row_col = minimumMatrixElementIndexes(distance_matrix)
    first_pwm_index = min_pwm_row_col[[1]]
    second_pwm_index = min_pwm_row_col[[2]]
    pwms_alignment = alignPwmSets(tree_nodes[[first_pwm_index]]$pwms,
                                  tree_nodes[[first_pwm_index]]$pwms_alignment,
                                  tree_nodes[[second_pwm_index]]$pwms,
                                  tree_nodes[[second_pwm_index]]$pwms_alignment,
                                  try_reverse_complement)
    stopifnot(length(c(tree_nodes[[first_pwm_index]]$pwms, tree_nodes[[second_pwm_index]]$pwms)) == length(pwms_alignment$vector))
    tree_nodes = c(tree_nodes,
                   list(
                       list("pwms"=c(tree_nodes[[first_pwm_index]]$pwms, tree_nodes[[second_pwm_index]]$pwms),
                            "left_child"=tree_nodes[[first_pwm_index]],
                            "right_child"=tree_nodes[[second_pwm_index]],
                            "num_leafs"=tree_nodes[[first_pwm_index]]$num_leaf + tree_nodes[[second_pwm_index]]$num_leaf,
                            "node_number"=join_counter,
                            "pwms_alignment" = pwms_alignment
                          )
                    )
                );
    join_counter = join_counter+1
    tree_nodes[[first_pwm_index]] = NULL
    tree_nodes[[second_pwm_index-1]] = NULL
    distance_matrix = matrix(distance_matrix[-c(first_pwm_index, second_pwm_index), -c(first_pwm_index, second_pwm_index)],
        nrow = nrow(distance_matrix)-2, ncol = ncol(distance_matrix)-2)
    if (ncol(distance_matrix) != 0) {
        distance_matrix = addLastTreeNodeToDistanceMatrix(distance_matrix, tree_nodes, try_reverse_complement)
    }
    return(list("distance_matrix"=distance_matrix, "tree_nodes"=tree_nodes))
}

alignmentTree = function(pwms, distance_matrix, try_reverse_complement) {
    tree_nodes = list()
    for (i in 1:length(pwms)) {
        tree_nodes = c(tree_nodes,
                       list(
                            list(   "pwms"=list(pwms[[i]]),
                                    "left_child"=NULL,
                                    "right_child"=NULL,
                                    "num_leafs"=1,
                                    "pwm_index"=i,
                                    "pwms_alignment"=list("vector"=list(list("direction"="forward", "shift"=0)))
                            )
                        )
                    );
    }
    join_counter = 1
    for (step in 1:(length(pwms)-1)) {
        joined = joinTwoNodesInAlignmentTree(distance_matrix, tree_nodes, join_counter, try_reverse_complement)
        distance_matrix = joined$distance_matrix
        tree_nodes = joined$tree_nodes
        join_counter = join_counter+1
    }
    return(tree_nodes[[1]])
}

alignmentTreeLeftRightTriversal = function(node) {
    merge = list()
    order = list()
    height = list()
    leftRightTreeTriversalHelper = function(node){
        if (is.null(node$left_child)) {
            order <<- c(order, node$pwm_index)
            return(-(node$pwm_index))
        } else {
            left_index = leftRightTreeTriversalHelper(node$left_child)
            right_index = leftRightTreeTriversalHelper(node$right_child)
            merge <<- c(merge, list(c(left_index, right_index)))
            height <<- c(height, list(node$pwms_alignment$divergence))
            #height <<- c(height, list(node$node_number))
        }
        return(length(merge))
    }
    leftRightTreeTriversalHelper(node)
    return(list("merge"=merge, "order"=unlist(order), "height"=height))
}


##' Creates a multiple alignment of pwms
##'
##' @title Multiple PWMs alignment
##' @param pwms list of pwms
##' @param divergence Divergence measure.
##' @param unaligned_penalty is a function for localPwmAlignment.
##' @param try_reverse_complement if True, alignment will try reverse complement pwms
##' @param base_distribution is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @param length_normalization If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.
##' @export
##' @return list
##' @author Lando Andrey
##' @examples 
##' file1 = system.file("extdata/homer/Max.motif",   package = "DiffLogo")
##' file2 = system.file("extdata/homer/c-Myc.motif", package = "DiffLogo")
##' pwm1 = getPwmFromFile(file1)
##' pwm2 = getPwmFromFile(file2)
##' 
##' multiple_pwms_alignment = multipleLocalPwmsAlignment(list(pwm1, pwm2))
multipleLocalPwmsAlignment = function(
  pwms,
  divergence=shannonDivergence,
  unaligned_penalty=divergencePenaltyForUnaligned,
  try_reverse_complement=TRUE,
  base_distribution=NULL,
  length_normalization = FALSE)
{
    distance_matrix = pwmsDistanceMatrix(
        pwms,
        bottom_default_value = Inf,
        diagonal_value = Inf,
        divergence=divergence,
        unaligned_penalty=unaligned_penalty,
        try_reverse_complement=try_reverse_complement,
        base_distribution=base_distribution,
        length_normalization = length_normalization);
    alignment_tree_nodes = alignmentTree(pwms, distance_matrix, try_reverse_complement)
    traversal_result = alignmentTreeLeftRightTriversal(alignment_tree_nodes)
    alignment_tree_nodes$pwms_alignment$vector = alignment_tree_nodes$pwms_alignment$vector[ sort.list( unlist( traversal_result$order))];
    alignment_length = 0;
    for (i in 1:length(pwms)) {
        alignment_length = max( alignment_length, ncol(pwms[[i]]) + alignment_tree_nodes$pwms_alignment$vector[[i]]$shift);
    }
    return(list("alignment"=alignment_tree_nodes$pwms_alignment,
                "order"=unlist(traversal_result$order),
                "merge"=t(matrix(unlist(traversal_result$merge), 2, byrow=FALSE)),
                "height"=unlist(traversal_result$height),
                "raw_tree"=list(alignment_tree_nodes),
                "distance_matrix"=distance_matrix,
                "alignment_length"=alignment_length
                ))
}

library(testthat)

pwm1 = matrix( c(0.6, 0.2, 0.1, 0.1,
                 0.3, 0.3, 0.2, 0.2,
                 0.1, 0.1, 0.2, 0.6,
                 0.15, 0.35, 0.25, 0.25,
                 0.85, 0.05, 0.05, 0.05,
                 0.2, 0.1, 0.3, 0.4), 4, 6)
rownames(pwm1) = c("A", "C", "G", "T")
pwm1_shifted = cbind(pwm1[,2:6], pwm1[,1])
pwm1_revcomp = pwm1[4:1, 6:1]
rownames(pwm1_revcomp) = c("A", "C", "G", "T")
pwm1_revcomp_shifted = cbind(cbind(pwm1_revcomp[,3:6], pwm1_revcomp[,1:1]),
                                                       pwm1_revcomp[,1:1])

ACTG_pwm = matrix( c(1 ,0 ,0, 0,
                     0 ,1 ,0, 0,
                     0, 0 ,0 ,1,
                     0, 0, 1, 0), 4, 4)
TGAC_pwm =  cbind(matrix(c(0.25,0.25,0.25,0.25), 4, 1),
                  ACTG_pwm[4:1, 4:1],
                  matrix(c(0.25,0.25,0.25,0.25), 4, 1) )

test_that("SameLengthMatrixesAlign", {
    alignment = localPwmAlignment(pwm1, pwm1)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'forward')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(pwm1, pwm1_shifted)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 1)
    expect_equal(alignment$vector[[2]]$direction, 'forward')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(pwm1_shifted, pwm1)
    expect_equal(alignment$vector[[1]]$shift, 1)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'forward')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(pwm1, pwm1_revcomp)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'reverse')
    expect_equal(alignment$divergence, 0)

    alignment = localPwmAlignment(pwm1_revcomp, pwm1)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'reverse')

    alignment = localPwmAlignment(pwm1, pwm1_revcomp_shifted)
    expect_equal(alignment$vector[[1]]$shift, 1)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'forward')
})

short_pwm_inside = pwm1[,2:4]
short_pwm_shifted = cbind(pwm1[,2:4], pwm1[,1])

test_that("DifferentLengthMatrixesAlign", {
    alignment = localPwmAlignment(pwm1, short_pwm_inside)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 3)
    expect_equal(alignment$vector[[2]]$direction, 'reverse')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(short_pwm_inside, pwm1)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'reverse')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(pwm1, short_pwm_shifted)
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 1)
    expect_equal(alignment$vector[[2]]$direction, 'forward')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(short_pwm_shifted, pwm1)
    expect_equal(alignment$vector[[1]]$shift, 1)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'forward')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(pwm1, revCompPwm(short_pwm_shifted))
    expect_equal(alignment$vector[[1]]$shift, 0)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 1)
    expect_equal(alignment$vector[[2]]$direction, 'reverse')
    expect_gte(alignment$divergence, 0)

    alignment = localPwmAlignment(ACTG_pwm, TGAC_pwm)
    expect_equal(alignment$vector[[1]]$shift, 1)
    expect_equal(alignment$vector[[1]]$direction, 'forward')
    expect_equal(alignment$vector[[2]]$shift, 0)
    expect_equal(alignment$vector[[2]]$direction, 'reverse')
    expect_gte(alignment$divergence, 0)
})

test_that("createDiffLogoObjRespectsAlignPwmObj", {
    diffLogoObj = createDiffLogoObject(pwm1, pwm1_revcomp)
    expect_gt(diffLogoObj$distance, 0)

    diffLogoObj = createDiffLogoObject(pwm1, pwm1_revcomp, align_pwms=T)
    expect_equal(diffLogoObj$distance, 0, tolerance=1e-5)
});

test_that("createDiffLogoObjAcceptsExtendedPwms", {
    pwm_list = list(pwm1, pwm1_revcomp_shifted)
    alignment = multipleLocalPwmsAlignment(pwm_list)
    extended_pwms = extendPwmsFromAlignmentVector(pwm_list,
                                                  alignment$alignment$vector)
    diffLogoObj = createDiffLogoObject(extended_pwms[[1]],
                                       extended_pwms[[2]], align_pwms=T)
    expect_equal(is.null(diffLogoObj), F)
});

test_that("extendPwmsFromAlignmentVector", {
    alignment = localPwmAlignment(pwm1, short_pwm_shifted)
    extended_pwms_alignment = extendPwmsFromAlignmentVector(
        list(pwm1, short_pwm_shifted),
        alignment$vector)
    expect_equal(alignment$divergence,
                 localPwmAlignment(pwm1, short_pwm_shifted)$divergence,
                 tolerance=1e-5)
    expect_equal(ncol(extended_pwms_alignment$pwms[[1]]),
                 ncol(extended_pwms_alignment$pwms[[2]]))
});

test_that("pwmDistanceMatrixForTwoPwms", {
    two_pwms_distance_matrix = pwmsDistanceMatrix(list(pwm1, short_pwm_shifted),
                                                  diagonal_value=999,
                                                  bottom_default_value=-1)
    expect_equal(ncol(two_pwms_distance_matrix), 2)
    expect_equal(nrow(two_pwms_distance_matrix), 2)

    expect_equal(two_pwms_distance_matrix[[1, 2]],
                 localPwmAlignment(pwm1, short_pwm_shifted)$divergence)
    expect_equal(two_pwms_distance_matrix[[2, 1]],
                 -1)
    expect_equal(two_pwms_distance_matrix[[1, 1]], 999)
    expect_equal(two_pwms_distance_matrix[[2, 2]], 999)
});

test_that("pwmDistanceMatrixForTreePwms", {
    three_pwms_distance_matrix = pwmsDistanceMatrix(list(pwm1,
                                                         short_pwm_shifted,
                                                         ACTG_pwm),
                                                    diagonal_value = Inf,
                                                    bottom_default_value = Inf)
    expect_equal(ncol(three_pwms_distance_matrix), 3)
    expect_equal(nrow(three_pwms_distance_matrix), 3)
    expect_equal(three_pwms_distance_matrix[[1, 2]],
                 localPwmAlignment(pwm1, short_pwm_shifted)$divergence)
    expect_equal(three_pwms_distance_matrix[[1, 3]],
                 localPwmAlignment(pwm1, ACTG_pwm)$divergence)
    expect_equal(three_pwms_distance_matrix[[2, 3]],
                 localPwmAlignment(short_pwm_shifted, ACTG_pwm)$divergence)

    expect_equal(three_pwms_distance_matrix[[2, 1]], Inf)
    expect_equal(three_pwms_distance_matrix[[3, 1]], Inf)
    expect_equal(three_pwms_distance_matrix[[3, 2]], Inf)

    expect_equal(three_pwms_distance_matrix[[1, 1]], Inf)
    expect_equal(three_pwms_distance_matrix[[2, 2]], Inf)
    expect_equal(three_pwms_distance_matrix[[3, 3]], Inf)
});

test_that("minimumMatrixRowCol", {
    mat = matrix(c(5,3,2,
                   2,2,0,
                   3,1,2), ncol=3, byrow=T)
    min_row_col = minimumMatrixElementIndexes(mat)
    expect_equal(min_row_col[[1]], 2)
    expect_equal(min_row_col[[2]], 3)

    mat = matrix(c(5,7,0,
                   1,2,4,
                   3,4,2), ncol=3, byrow=T)
    min_row_col = minimumMatrixElementIndexes(mat)
    expect_equal(min_row_col[[1]], 1)
    expect_equal(min_row_col[[2]], 3)
});

test_that("addLastTreeNodeToDistanceMatrix", {
    mat = matrix(c(0,0,
                   0,0), ncol=2, byrow=T)
    tree_nodes = list(list("pwms"=list(pwm1)
                          ,"pwms_alignment"=list(
                             "vector"=list(list("shift"=0,
                                                "direction"="forward"))
                            ,"divergence"=2))
                     ,list("pwms"=list(pwm1, ACTG_pwm)
                          ,"pwms_alignment"=list(
                             "vector"=list(list("shift"=0,
                                                "direction"="forward")
                                          ,list("shift"=1,
                                                "direction"="reverse"))
                            ,"divergence"=3))
                     ,list("pwms"=list(pwm1_revcomp_shifted)
                          ,"pwms_alignment"=list(
                             "vector"=list(list("shift"=0,
                                                "direction"="forward"))
                            ,"divergence"=4)))
    new_distance_matrix = addLastTreeNodeToDistanceMatrix(mat, tree_nodes)
    expect_equal(new_distance_matrix[[3, 1]], Inf) 
    expect_equal(new_distance_matrix[[1, 3]], localPwmAlignment(
                                                pwm1,
                                                pwm1_revcomp_shifted)$divergence)
});

test_that("joinTwoNodesInAlignmentTree", {
    mat = matrix(c(Inf, 2,1,
                   Inf,Inf,2,
                   Inf,Inf,Inf), ncol=3, byrow=T)
    tree_nodes = list(list("pwms"=list(pwm1)
                          ,"pwms_alignment"=list(
                             "vector"=list(list("shift"=0,
                                                "direction"="forward"))
                            ,"divergence"=2))
                     ,list("pwms"=list(pwm1, ACTG_pwm)
                          ,"pwms_alignment"=list(
                             "vector"=list(list("shift"=0,
                                                "direction"="forward")
                                          ,list("shift"=1,
                                                "direction"="reverse"))
                            ,"divergence"=3))
                     ,list("pwms"=list(pwm1_revcomp_shifted)
                          ,"pwms_alignment"=list(
                             "vector"=list(list("shift"=0,
                                                "direction"="forward"))
                            ,"divergence"=4)))
    joined = joinTwoNodesInAlignmentTree(mat, tree_nodes, 3)
    expect_equal(length(joined), 2)
});


test_that("multipleLocalPwmsAlignment", {
    alignment = multipleLocalPwmsAlignment(list(pwm1,
                                                pwm1_revcomp_shifted,
                                                ACTG_pwm))

    pwms_list = list(pwm1, pwm1_revcomp_shifted, ACTG_pwm)
    names(pwms_list) = sapply(1:length(pwms_list), paste)
    alignment = multipleLocalPwmsAlignment(pwms_list)
});


test_that("diffLogoTablePlotsWithoutAligning", {
    pwm_list = list(pwm1, pwm1_revcomp_shifted, ACTG_pwm)
    alignment = multipleLocalPwmsAlignment(pwm_list)
    extended_pwms = extendPwmsFromAlignmentVector(pwm_list,
                                                  alignment$alignment$vector)
    diffLogoTable(extended_pwms, list("", "", ""))
    diffLogoTable(list(pwm1, pwm1_revcomp_shifted, ACTG_pwm), names=1:3,
                  configuration=list("multiple_align_pwms"=T))
    diffLogoTable(list(pwm1, pwm1_revcomp_shifted, ACTG_pwm), names=1:3,
                  configuration=list(enableClustering=T, multiple_align_pwms=T))
});

##' Creates a matrix-representation of a PWM from a set of sequences
##'
##' @title Create PWM from alignment
##' @param alignment a vector or list of sequences each with equal length
##' @param alphabet of type Alphabet
##' @param pseudoCount the number of pseudo-observations for each character in the alphabet
##' @return PWM as matrix
##' @export
##' @author Hendrik Treutler
##' @examples
##' motif_folder= "extdata/alignments"
##' motif_name = "calamodulin_1"
##' fileName = paste(motif_folder,"/",motif_name,".txt",sep="")
##' file = system.file(fileName, package = "DiffLogo")
##' motif = getPwmFromAlignment(readLines(file), ASN, 1)
##' seqLogo(pwm = motif, alphabet=ASN)
getPwmFromAlignment = function(alignment, alphabet=NULL, pseudoCount=0) {
    alignment <- gsub("\\s+", "", alignment)
    alignment <- alignment[!grepl(pattern = "^$", x = alignment)]
    
    if(is.null(alphabet))
      alphabet <- getAlphabetFromSequences(alignment)
    
    alphabetSize = alphabet$size
    alignmentLength = nchar(alignment[[1]])
    numberOfSequences = length(alignment)
    
    if(length(unique(unlist(lapply(X = alignment, FUN = nchar)))) > 1)
      stop("Alignment comprises sequences with different lengths.")
    
    pwm = matrix(nrow = alphabetSize, ncol = alignmentLength)
    colnames(pwm) = 1:alignmentLength
    rownames(pwm) = alphabet$chars

    for(posIdx in 1:alignmentLength){
        for(charIdx in 1:alphabetSize){
            pwm[charIdx, posIdx] = (length(which(substr(alignment, posIdx, posIdx) == alphabet$chars[[charIdx]])) + pseudoCount) / (numberOfSequences + pseudoCount * alphabetSize)
        }
        if(sum(pwm[, posIdx]) == 0) {
            # nothing was observed and no pseudoCount was set
            pwm[, posIdx] = rep(1/alphabetSize,alphabetSize);
        } else {
            # normalize pwm
            pwm[, posIdx] = pwm[, posIdx] / sum(pwm[, posIdx]);            
        }
    }
    return(pwm);
}

##' returns the alphabet which fits to the given sequences
##' 
##' @title returns the alphabet which fits to the given sequences
##' @param sequences a character vector of sequences
##' @return an alphabet of type Alphabet
##' 
##' @export
##' @examples 
##' alphabet = getAlphabetFromSequences("AACCGGTT")
getAlphabetFromSequences <- function(sequences){
    characters <- unique(unlist(strsplit(sequences, split = "")))
    alphabet <- getAlphabetFromCharacters(characters)
    return(alphabet)
}
##' returns the alphabet which fits to the given characters
##' 
##' @title returns the alphabet which fits to the given characters
##' @param characters a character vector of characters
##' @return an alphabet of type Alphabet
##' 
##' @export
##' @examples 
##' alphabet = getAlphabetFromSequences(c("A","A","C","C","G","G","T","T"))
getAlphabetFromCharacters <- function(characters){
    chars <- paste(sort(characters), collapse = "")
  
    dnaRegEx <- paste("^\\-?", paste(sort(DNA$chars), "?", sep = "", collapse = ""), "$", sep = "")
    rnaRegEx <- paste("^\\-?", paste(sort(RNA$chars), "?", sep = "", collapse = ""), "$", sep = "")
    asnRegEx <- paste("^\\-?", paste(sort(ASN$chars), "?", sep = "", collapse = ""), "$", sep = "")
  
    if(grepl(pattern = dnaRegEx, x = chars)){
        return(DNA)
    } else if(grepl(pattern = rnaRegEx, x = chars)){
        return(DNA)
    } else if(grepl(pattern = asnRegEx, x = chars)){
        return(ASN)
    } else{
        warning(paste("Unrecognized alphabet (not DNA, RNA, or ASN):", chars))
        return(FULL_ALPHABET)
    }
}
##' Generates a pwm from a file of different formats. 
##' Supported formats are FASTA files (.fa, .fasta), alignment files (.txt, .text, .al, .alignment), PWM files (.pwm), JASPAR / Position Frequency Matrix files (.pfm), and homer files (.motif).
##' 
##' @title generates a pwm from a file of different formats
##' @param filename the file
##' @return a pwm
##' 
##' @export
##' @examples 
##' fileName = "extdata/pwm/H1-hESC.pwm"
##' file = system.file(fileName, package = "DiffLogo")
##' pwm = getPwmFromFile(file)
getPwmFromFile <- function(filename){
  extension <- tolower(tools::file_ext(filename))
  
  pwm <- NULL
  error <- NULL
  tryCatch(
    {
      if(extension == "fa" || extension == "fasta")
        pwm <- getPwmFromFastaFile(filename)
      if(extension == "txt" || extension == "text" || extension == "al" || extension == "alignment")
        pwm <- getPwmFromAlignmentFile(filename)
      if(extension == "pwm")
        pwm <- getPwmFromPwmFile(filename)
      if(extension == "pfm")
        pwm <- getPwmFromPfmOrJasparFile(filename)
      if(extension == "motif")
        pwm <- getPwmFromHomerFile(filename)
    }, 
    error = function(e) {
      error <- e
    }
  )
  
  if(!is.null(error)) {
    stop(paste("Could not parse file", basename(filename), ". Error:", error))
  }
  if(is.null(pwm)) {
    stop(paste("The file extension", extension, "of file", basename(filename),"is not supported."))
  }
  
  return(pwm)
}

##' extracts the sequences from a FASTA file
##' 
##' @title extracts the sequences from a FASTA file
##' @param filename the FASTA file
##' @return a vector of sequences
##' @importFrom utils read.delim
##' @export
##' @examples 
##' fileName = "extdata/alignments/F-box_bacteria.seq.fa"
##' file = system.file(fileName, package = "DiffLogo")
##' sequences = getSequencesFromFastaFile(file)
getSequencesFromFastaFile = function(filename) {
    connection = file(filename ,open="r");
    lines = as.vector(read.delim(connection)[,1]);
    close(connection);
    lines = lines[grep("^[^>]",lines)]
    lines = lines[sapply(lines,nchar) > 0]; # remove empty lines
    lines = toupper(lines);
    return(lines);
}


##' generates a pwm from a FASTA file
##' 
##' @title generates a pwm from a FASTA file
##' @param filename the FASTA file
##' @param alphabet the desired alphabet of type Alphabet
##' @return a pwm
##' 
##' @export
##' @examples 
##' fileName = "extdata/alignments/F-box_bacteria.seq.fa"
##' file = system.file(fileName, package = "DiffLogo")
##' pwm = getPwmFromFastaFile(file)
getPwmFromFastaFile = function(filename,alphabet=NULL) {
    lines = getSequencesFromFastaFile(filename);
    pwm <- getPwmFromAlignment(alignment = lines, alphabet = alphabet)
    return(pwm);
}

##' extracts the sequences from an alignment file
##' 
##' @title extracts the sequences from an alignment file
##' @param filename the alignment file
##' @return a vector of sequences
##' @importFrom utils read.delim
##' @export
##' @examples 
##' fileName = "extdata/alignments/calamodulin_1.txt"
##' file = system.file(fileName, package = "DiffLogo")
##' sequences = getSequencesFromAlignmentFile(file)
getSequencesFromAlignmentFile = function(filename) {
    connection = file(filename ,open="r");
    lines = as.vector(read.delim(connection)[,1]);
    close(connection);
    lines = lines[sapply(lines,nchar) > 0]; # remove empty lines
    lines = toupper(lines);
    return(lines);
}

##' generates a pwm from an alignment file
##' 
##' @title generates a pwm from an alignment file
##' @param filename the alignment file
##' @param alphabet the desired alphabet of type Alphabet
##' @return a pwm
##' 
##' @export
##' @examples 
##' fileName = "extdata/alignments/calamodulin_1.txt"
##' file = system.file(fileName, package = "DiffLogo")
##' pwm = getPwmFromAlignmentFile(file)
getPwmFromAlignmentFile = function(filename,alphabet=NULL) {
    lines = getSequencesFromAlignmentFile(filename);
    pwm <- getPwmFromAlignment(alignment = lines, alphabet = alphabet)
    return(pwm);
}

##' generates a pwm from a pwm file
##' 
##' @title generates a pwm from a pwm file
##' @param filename the pwm file
##' @return a pwm
##' @importFrom utils read.delim
##' @export
##' @examples 
##' fileName = "extdata/pwm/H1-hESC.pwm"
##' file = system.file(fileName, package = "DiffLogo")
##' pwm = getPwmFromPwmFile(file)
getPwmFromPwmFile = function(filename) {
    lines = readLines(filename);
    # replace all whitespaces by one " "
    lines = gsub("\\s+", " ", lines);
    tc = textConnection(lines);
    pwm = as.matrix(read.delim(tc, sep=" ", header=FALSE));
    close(tc);
    pwm = normalizePWM(pwm);
    return(pwm);
}

##' generates a pwm from a jaspar file
##' 
##' @title generates a pwm from a jaspar file
##' @param filename the jaspar file
##' @return a pwm
##' @importFrom utils read.delim
##' @export
##' @examples 
##' fileName = "extdata/pfm/ctcf_jaspar.pfm"
##' file = system.file(fileName, package = "DiffLogo")
##' pwm = getPwmFromPfmOrJasparFile(file)
getPwmFromPfmOrJasparFile = function(filename) {
    lines = readLines(filename);
    lines = lines[grep("^[^>]",lines)]
    # replace all whitespaces by one " "
    lines = gsub("\\s+", " ", lines);
    # remove ACGT
    lines = gsub("[ACGT]", "", lines);    
    # remove opening gap
    lines = gsub("\\s+\\[", "", lines);
    lines = gsub("\\s+\\]", "", lines);
    tc = textConnection(lines);
    pwm = as.matrix(read.delim(tc, sep=" ", header=FALSE));
    close(tc);
    pwm = normalizePWM(pwm);
    return(pwm);
}

##' generates a pwm from a homer file
##' 
##' @title generates a pwm from a homer file
##' @param filename the homer file
##' @return a pwm
##' @importFrom utils read.delim
##' @export
##' @examples 
##' fileName = "extdata/homer/CTCF_Zf_CD4.motif"
##' file = system.file(fileName, package = "DiffLogo")
##' pwm = getPwmFromHomerFile(file)
getPwmFromHomerFile = function(filename) {
    # First read lines
    lines = readLines(filename);
    lines = lines[grep("^[^>]",lines)]
    # replace all whitespaces by one " "
    lines = gsub("\\s+", " ", lines);
    tc = textConnection(lines);
    pwm = as.matrix(read.delim(tc, sep=" ", header=FALSE));
    close(tc);

    # transpose
    pwm = t(pwm); 
    pwm = normalizePWM(pwm);
    return(pwm);
}

##' normalizes the given pwm to column-sums of 1.0
##' 
##' @title normalizes the given pwm
##' @param pwm a pwm
##' @return a normalized pwm
##' 
##' @export
##' @examples 
##' pwm = matrix(1:40, nrow = 4, dimnames = list(c("A","C","G","T"), 1:10))
##' pwm = normalizePWM(pwm)
normalizePWM = function(pwm) {
    for( i in 1:ncol(pwm)) {
        pwm[,i] = pwm[,i] / sum(pwm[,i]);
    }
    return(pwm);
}

library(DiffLogo)
context("Utilities")


expectation = matrix(nrow = DNA$size, ncol = 1)
colnames(expectation) = 1
rownames(expectation) = DNA$chars
expectation[,1]=c(.4,.3,.2,.1)

expectation2 = matrix(nrow = DNA$size, ncol = 1)
colnames(expectation2) = 1
rownames(expectation2) = DNA$chars
expectation2[,1]=(c(4,3,2,1)+2)/(10+4*2)


input = c("A","A","A","A","C","C","C","G","G","T");
test_that("getPwmFromAlignment", {
   expect_equal(getPwmFromAlignment(input,DNA,0), expectation)
   expect_equal(getPwmFromAlignment(input,DNA,2), expectation2)
})

##' probability differences normalized by the sum of absolute probability differences for the given pair of probability vectors
##'
##' @title normalized probability differences
##' @param p1 probability vector representing the first symbol distribution
##' @param p2 probability vector representing the second symbol distribution
##' @return a vector with one result for each symbol
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, baseDistribution = normalizedDifferenceOfProbabilities)
normalizedDifferenceOfProbabilities = function(p1,p2) {
    # if p is identical to q, return uniform distribution
    if(all(p1==p2)) {
        return( rep(1/length(p1),length(p1)) )
    }
    tmp = p1-p2;
    return( tmp / sum(abs(tmp)));
}

##' information content differences normalized by the sum of absolute information content differences for the given pair of probability vectors
##'
##' @title normalized information content differences
##' @param p1 probability vector representing the first symbol distribution
##' @param p2 probability vector representing the second symbol distribution
##' @return a vector with one result for each symbol
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, baseDistribution = differenceOfICs)
differenceOfICs = function(p1,p2) {
    # if p is identical to q, return uniform distribution
    if(all(p1==p2)) {
        return( rep(1/length(p1),length(p1)) )
    }
    H1 = informationContent(p1)$height;
    H2 = informationContent(p2)$height;
    hts1 = H1*p1;
    hts2 = H2*p2
    diff = hts1 - hts2
    return( diff / sum(abs(diff)));
}

##' the given probabilities
##'
##' @title probabilities
##' @param p probability vector representing the symbol distribution
##' @return the given vector
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_name = "HepG2"
##' fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
##' file = system.file(fileName, package = "DiffLogo")
##' motif = getPwmFromPwmFile(file)
##' seqLogo(pwm = motif, baseDistribution = probabilities)
probabilities = function(p) {
  return(p);
}

library(DiffLogo)
context("Base Distributions")

a=c(1,0,0,0)
b=c(0,1,0,0)
c=c(0.5,0.5,0,0)
d=c(0,0,0.5,0.5)
e=c(0,0.5,0.5,0)
f=c(.25,.25,.25,.25)


test_that("sumOfAbsProbabilityDifferences", {
   expect_equal(normalizedDifferenceOfProbabilities(a,a), c(.25,.25,.25,.25))
   expect_equal(normalizedDifferenceOfProbabilities(a,b), c(.5,-.5,0,0))
   expect_equal(normalizedDifferenceOfProbabilities(b,a), c(-.5,.5,0,0))
   expect_equal(normalizedDifferenceOfProbabilities(c,d), c(.25,.25,-.25,-.25))
   expect_equal(normalizedDifferenceOfProbabilities(c,e), c(.5,0,-.5,0))
   expect_equal(normalizedDifferenceOfProbabilities(e,f), c(-.25,.25,.25,-.25))
})

test_that("differenceOfICs", {
   expect_equal(differenceOfICs(a,a), c(.25,.25,.25,.25))
   expect_equal(differenceOfICs(a,b), c(.5,-.5,0,0))
   expect_equal(differenceOfICs(b,a), c(-.5,.5,0,0))
   expect_equal(differenceOfICs(c,d), c(.25,.25,-.25,-.25))
   expect_equal(differenceOfICs(c,e), c(.5,0,-.5,0))
   expect_equal(differenceOfICs(e,f), c(.0,.5,.5,0))
   expect_equal(differenceOfICs(f,e), c(.0,-.5,-.5,0))
})

##' Draws the classic sequence logo. 
##'
##' @title Draw sequence logo
##' @param pwm representation of a position weight matrix (PWM) of type pwm, data.frame, or matrix
##' @param sparse if TRUE margins are reduced and tickmarks are removed from the logo
##' @param drawLines distance between background lines
##' @param stackHeight function for the height of a stack at position i
##' @param baseDistribution function for the heights of the individual bases
##' @param alphabet of type Alphabet
##' @param main the main title for the plot
##' @return none (draws sequence logo)
##' @importFrom graphics plot abline axis polygon
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_name = "HepG2"
##' fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
##' file = system.file(fileName, package = "DiffLogo")
##' motif = getPwmFromPwmFile(file)
##' seqLogo(pwm = motif)
seqLogo = function (pwm, sparse=FALSE, drawLines=0.5, stackHeight=informationContent, baseDistribution=probabilities, alphabet=DNA, main=NULL) { 
    pwm = preconditionTransformPWM(pwm,alphabet);
    preconditionPWM(pwm);

    letters = list(x = NULL, y = NULL, id = NULL, fill = NULL)
    npos = ncol(pwm)

    ylim.negMax = 0;
    ylim.posMax = 0;
   
    wt = 1.0
    x.pos = 0.5 # initial position on x axis is 0.5; Letter is one right from this point
    eps = 0; # spacer between two bases in one stack
    heights = c(); ymins=c(); ymaxs=c()
    for (j in 1:npos) {
        column = pwm[, j]
        sh = stackHeight(column);
        hts = baseDistribution(column) * sh$height ;
        letterOrder = order(abs(hts)) # reorder letters
        yneg.pos = 0 
        ypos.pos = 0
        for (i in 1:alphabet$size) {
            ht = hts[letterOrder[i]]
            y.pos = ypos.pos;
            ht = ht - eps;
            ypos.pos = ypos.pos + ht + eps
            char = alphabet$chars[letterOrder[i]]
            col = alphabet$cols[letterOrder[i]];
            letters = addLetter(letters, letterPolygons[[char]], x.pos, y.pos, ht, wt*0.99, col=col)
        }
        x.pos = x.pos + wt
    }
    if(sparse) {
        plot(NA, xlim=c(0.5,x.pos), ylim=c(0,log2(alphabet$size)),xaxt="n", ylab="",
        mgp=c(0, .35, 0),tck=-0.02, cex.axis=0.8, frame.plot=FALSE,xlab="", main=main)
    } else {
        plot(NA, xlim=c(0.5,x.pos), ylim=c(0,log2(alphabet$size)), xaxt="n", ylab=sh$ylab, frame.plot=FALSE,xlab="Position", main=main)
    }

    for(y in seq(0,log2(alphabet$size),drawLines)) {
        abline(y,0,col="gray");
    }
    
    if(sparse) {
        axis(1,labels=c("",rep("",npos),""), at=c(0,1:npos,npos+1),tck=-0.02)
    } else {
        axis(1,labels=c("",1:npos,""),at=c(0,1:npos,npos+1))
    }
    polygon(letters, col=letters$col, border=NA)
}


# appends the letter which to the object letters
addLetter = function (letters, letterPolygon, x.pos, y.pos, ht, wt, col="black") {
    x = x.pos + wt * letterPolygon$x
    y = y.pos + ht * letterPolygon$y
    polygons = sum(is.na(x))+1  # a letter can consist of more then one polygon
    letters$x = c(letters$x, NA, x)
    letters$y = c(letters$y, NA, y)
    letters$col = c(letters$col, rep(col, polygons))
    letters
}

##' Default configuration list for diffLogoTable
##'
##' @title Configuration object for diffLogoTable
##' @param alphabet used alphabet of type Alphabet
##' @param stackHeight function for the height of a stack at position i
##' @param baseDistribution function for the heights of the individual bases
##' @param uniformYaxis if TRUE each DiffLogo is plotted with the same scaling of the y-axis
##' @param sparse if TRUE margins are reduced and tickmarks are removed from the logo
##' @param showSequenceLogosTop if TRUE the classical sequence logos are drawn above each column of the table
##' @param enableClustering if TRUE the motifs are reordered, so that similar motifs have a small vertical and horizontal distance in the table
##' @param treeHeight the height of the plotted cluster tree above the columns of the table; set equal to zero to omit the cluster tree
##' @param margin the space reseverved for labels
##' @param ratio the ratio of the plot; this is needed to determine the margin sizes correctly
##' @param align_pwms if True, will align and extend pwms in each cell of diffLogoTable independently.
##' @param multiple_align_pwms if True, will align and extend pwms in the diffLogoTable jointly.
##' @param unaligned_penalty is a function for localPwmAlignment.
##' @param try_reverse_complement if True, alignment will try reverse complement pwms
##' @param length_normalization if True, divergence between pwms is divided by length of pwms.
##' @param numberOfPermutations number of permutations for the permutation test for the calculation of p-values
##' @return list of parameters
##' @export
##' @author Lando Andrey
##' @examples
##' diffLogoTableConfiguration(DNA)
diffLogoTableConfiguration = function(
		alphabet,
		stackHeight=shannonDivergence,
		baseDistribution=normalizedDifferenceOfProbabilities,
		uniformYaxis=TRUE,
		sparse=TRUE,
		showSequenceLogosTop=TRUE,
		enableClustering=TRUE,
		treeHeight=0.5,
		margin=0.02,
		ratio=1,
		align_pwms=FALSE,
		multiple_align_pwms=TRUE,
		unaligned_penalty=divergencePenaltyForUnaligned,
		try_reverse_complement=TRUE,
		length_normalization=FALSE,
		numberOfPermutations=100) {
    #if (!alphabet$supportReverseComplement) {
    #   try_reverse_complement = F;
    #}
    return(
      list(
    		uniformYaxis=uniformYaxis,
    		sparse=sparse,
    		showSequenceLogosTop=showSequenceLogosTop,
    		enableClustering=enableClustering,
    		treeHeight=treeHeight,
    		margin=margin,
    		ratio=ratio,
    		stackHeight=stackHeight,
    		baseDistribution=baseDistribution,
    		multiple_align_pwms=multiple_align_pwms,
    		align_pwms=align_pwms,
    		unaligned_penalty=unaligned_penalty,
    		try_reverse_complement=try_reverse_complement && alphabet$supportReverseComplement,
    		length_normalization=length_normalization,
    		numberOfPermutations=numberOfPermutations)
    )
}

getMarginsDiffLogo = function(sparse) {
	if(sparse) {
		return(c(0.3,1.2,0.1,0.1));
	} else {
		return(c(1,1.5,0.1,0.1));
	}
}

getMarginsSeqLogo = function(sparse) {
	if(sparse) {
		return (c(0.3,1.2,0.0,0.1));
	} else {
		return (c(1,1.5,0.1,0.1));
	}
}

extractNames = function(PWMs) {
	names = names(PWMs);
    if (is.null(names)) {
        names = 1:length(PWMs)
    }
    return (names);
}

revCompPwm = function (pwm) {
    if(nrow(pwm) != 4)
      stop("Can only reverse complement DNA and RNA alphabet.")
    result = pwm[nrow(pwm):1, ncol(pwm):1]
    rownames(result) = rownames(pwm)
    return(result)
}


##' Counts PWM divergence as sum of divergencies of their columns.
##'
##' @title PWM divergence
##' @param pwm_left is a PWM representation in type of matrix
##' @param pwm_right is a PWM representation in type of matrix. The result is symmetric on pwm_left and pwm_right
##' @param divergence is a Divergence function on columns.
##' @return float - sum of divergences
##' @export
pwmDivergence = function(pwm_left, pwm_right, divergence=shannonDivergence) {
    stopifnot(ncol(pwm_left) == ncol(pwm_right));
    return(sum(sapply(1:ncol(pwm_left), function(i) {
        divergence(pwm_left[,i], pwm_right[,i])$height
    })));
}

##' Generates a PWM consisting of only the uniform distribution or the given base_distribution (if defined).
##' 
##' @title Generates a PWM
##' @param pwm_length the number of positions
##' @param alphabet_length the alphabet size
##' @param base_distribution optional base distribution for each PWM position
##' @return a PWM
baseDistributionPwm = function(pwm_length, alphabet_length, base_distribution=NULL) {
    if (is.null(base_distribution)) {
       base_distribution = rep(1.0/alphabet_length, each=alphabet_length)
    }
    return(matrix(rep(base_distribution, each=length, pwm_length), nrow=alphabet_length))
}

##' Enriches a matrix of difflogo objects with p-values which quantifies the probability that two PWM-positions are from the same distribution
##'
##' @title Enriches a matrix of difflogo objects with p-values
##' @param diffLogoObjMatrix matrix of difflogo objects
##' @param sampleSizes number of sequences behind the pwms behind the given difflogo objects
##' @param stackHeight function for the calculation of a divergence measure for two probability vectors
##' @param numberOfPermutations the number of permutations to perform for the calculation of stackHeights
##' @return matrix of difflogo objects enriched with p-values
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' sampleSizes <- c(100, 150, 200, 250)
##' names(sampleSizes) <- motif_names
##' 
##' diffLogoTableObj = prepareDiffLogoTable(motifs);
##' diffLogoTableObj$diffLogoObjMatrix = enrichDiffLogoTableWithPvalues(diffLogoTableObj$diffLogoObjMatrix, sampleSizes)
enrichDiffLogoTableWithPvalues <- function(diffLogoObjMatrix, sampleSizes, stackHeight=shannonDivergence, numberOfPermutations = 100 ) {
  if(is.null(sampleSizes))
    stop("No sample sizes given!")
  
  motifs = names(diffLogoObjMatrix);
  dim = length(motifs);
  for ( i in 1:dim) {
    for ( k in 1:dim) {
      motif_i = motifs[i];
      motif_k = motifs[k];
      if(!is.null(diffLogoObjMatrix[[motif_i]][[motif_k]])) {
        diffLogoObjMatrix[[motif_i]][[motif_k]] = enrichDiffLogoObjectWithPvalues(
                                                          diffLogoObjMatrix[[motif_i]][[motif_k]],
                                                          sampleSizes[[motif_i]],
                                                          sampleSizes[[motif_k]]
                                                    );
      }
    }
  }
  return(diffLogoObjMatrix);
}

##' Enriches a difflogo object with p-values which quantifies the probability that two PWM-positions are from the same distribution
##'
##' @title Enriches a difflogo object with p-values
##' @param diffLogoObj matrix of difflogo objects
##' @param n1 the number of sequences behind the first pwm behind the given difflogo object
##' @param n2 the number of sequences behind the second pwm behind the given difflogo object
##' @param stackHeight function for the calculation of a divergence measure for two probability vectors
##' @param numberOfPermutations the number of permutations to perform for the calculation of stackHeights
##' @return enriched difflogo object
##' @export
##' @examples 
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' n1 <- 100
##' n2 <- 100
##' diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
##' diffLogoObj = enrichDiffLogoObjectWithPvalues(diffLogoObj, n1, n2)
enrichDiffLogoObjectWithPvalues <- function(diffLogoObj, n1, n2, stackHeight=shannonDivergence, numberOfPermutations = 100) {
    pwm1 = diffLogoObj$pwm1
    pwm2 = diffLogoObj$pwm2
    npos = ncol(diffLogoObj$pwm1);
    pvals = rep(1,npos);
    for (j in (diffLogoObj$unaligned_from_left+1):(npos - diffLogoObj$unaligned_from_right)) {
      pvals[j] = calculatePvalue(p1 = pwm1[,j], p2 = pwm2[,j], n1 = n1, n2 = n2, stackHeight = stackHeight, numberOfPermutations = numberOfPermutations);
    }
    diffLogoObj$pvals = pvals;
    return(diffLogoObj);
} 


##' Calculates the p-value for the null-hypothesis that two given probability vectors p1, p2 calculated from n1/n2 observations arise from the same distribution
##'
##' @title p-value that two PWM-positions are from the same distribution
##' @param p1 first probability vector with one probability for each symbol of the alphabet
##' @param p2 second probability vector with one probability for each symbol of the alphabet
##' @param n1 number of observations for the calculation of p1
##' @param n2 number of observations for the calculation of p2
##' @param stackHeight function for the calculation of a divergence measure for two probability vectors
##' @param numberOfPermutations the number of permutations to perform for the calculation of stackHeights
##' @param plotGammaDistributionFit if TRUE the fit of a gamma distribution to the sampled stackHeights is plotted
##' @return a numeric p-value
##' @export
##' @importFrom stats var dgamma
##' @importFrom graphics plot lines legend
##' @author Hendrik Treutler
##' @examples
##' p1 <- c(0.2, 0.3, 0.1, 0.4)
##' p2 <- c(0.2, 0.1, 0.3, 0.4)
##' n1 <- 100
##' n2 <- 200
##' numberOfPermutations = 100
##' plotGammaDistributionFit = TRUE
##' 
##' pValue <- calculatePvalue(p1 = p1, p2 = p2, n1 = n1, n2 = n2, stackHeight = shannonDivergence, numberOfPermutations = numberOfPermutations, plotGammaDistributionFit = plotGammaDistributionFit)
calculatePvalue <- function(p1, p2, n1, n2, stackHeight=shannonDivergence, numberOfPermutations = 100, plotGammaDistributionFit = FALSE){
  ############################################################################################
  ## preconditions
  preconditionVectorSameSize(p1, p2)
  preconditionBaseDistribution(p1)
  preconditionBaseDistribution(p2)
  preconditionProbabilityVector(p1)
  preconditionProbabilityVector(p2)

  if(all(p1==p2)) {
    return(1);
  }

  if(any(is.na(n1), is.na(n2), is.null(n1), is.null(n2), !is.numeric(n1), !is.numeric(n2), n1<=0, n2<=0))
    stop("Given counts are corrupt!")
  
  ############################################################################################
  ## divergence to test
  height = stackHeight(p1 = p1, p2 = p2)
  preconditionStackHeight(height)
  observedDivergence = height$height
  
  ############################################################################################
  ## parameters
  alphabet <- 1:length(p1)
  p = (p1 + p2) / 2
  n = n1 + n2
  a = as.integer(round(p * n))
  # the rounding can cause that sum(a) != n
  n = sum(a);

  ############################################################################################
  ## permutations
  multiplier <- 1:length(alphabet)
  seed <- (sum((1 / (p1+1e-3)) * multiplier) * sum((1 / (p2+1e-3)) * multiplier)) %% 2147483647
  set.seed(seed)
  
  symbols <- unlist(sapply(X = alphabet, FUN = function(x){rep(x = x, times = a[[x]])}))
  classes <- c(rep(x = TRUE, times = n1), rep(x = FALSE, times = n - n1))

  divergences <- vector(mode = "numeric", length = numberOfPermutations)
  for(idx in 1:numberOfPermutations){
    newOrder = classes[sample(n)];
    symbols2 = symbols[newOrder]

    a1 = unlist(lapply(X = alphabet, FUN = function(x){sum(symbols2 == x)}))
    a2 = a - a1
    divergences[[idx]] = stackHeight(p1 = a1 / n1, p2 = a2 / n2)$height
  }
  maximumDivergence = max(max(divergences) * 2, observedDivergence * 2)
  
  ############################################################################################
  ## fit gamma distribution
  med.gam <- mean(divergences)
  var.gam <- var(divergences)
  rate <- med.gam/var.gam
  alpha <- ((med.gam)^2)/var.gam
  scale <- 1/rate
  
  gammaDistX <- seq(from=0, to=maximumDivergence, length.out = 10000)

  gammaDistY <- dgamma(x = gammaDistX, rate = rate, shape = alpha)
  if(gammaDistY[1] == Inf) {
    gammaDistY[1] = 0;
  }
  gammaDistY = gammaDistY / sum(gammaDistY)  
  gammaDistYcum = cumsum(gammaDistY)
  
  ############################################################################################
  ## plot
  if(plotGammaDistributionFit){
    cumSumValuesX <- sort(divergences)
    cumSumValuesY <- (1:numberOfPermutations) / numberOfPermutations
    
    plot(NA, xlim = c(0,maximumDivergence), ylim = c(0, 1), ylab = "p", xlab = "x", main = paste("p = (", paste(p, collapse = ","), "), n1 = ", n1, ", n2 = ", n2, sep = ""))
    lines(x = cumSumValuesX, y = cumSumValuesY, col = "blue")
    lines(x = gammaDistX, y = gammaDistYcum, col = "green")
    legend(x = max(divergences)/2, y = 0.3, legend = c("Empiric", paste("Gamma, k=", round(rate, digits = 2), ", theta=", round(alpha, digits = 2), sep = "")), lty = c(1, 1), col = c("blue", "green"))
  }
  
  ############################################################################################
  ## p-value
  pValue <- 1 - gammaDistYcum[[min(which(gammaDistX > observedDivergence))]]
  
  return(pValue)
}

##' the sum of absolute probability differences for the given pair of probability vectors
##'
##' @title sum of absolute probability differences
##' @param p1 probability vector representing the first symbol distribution
##' @param p2 probability vector representing the second symbol distribution
##' @return an object consisting of height and ylab
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, stackHeight = sumOfAbsProbabilityDifferences)
sumOfAbsProbabilityDifferences = function(p1,p2) {
    obj=list();
    # if p is identical to q, set height to 0
    if(all(p1==p2)) {
        obj$height=0;   
    } else {
        obj$height=sum( abs(p1 - p2));
    }
    obj$ylab="Probability";
    return(obj);
}

##' the sum of absolute information content differences for the given pair of probability vectors
##'
##' @title sum of absolute information content differences
##' @param p1 probability vector representing the first symbol distribution
##' @param p2 probability vector representing the second symbol distribution
##' @return an object consisting of height and ylab
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, stackHeight = sumOfAbsICDifferences)
sumOfAbsICDifferences = function(p1,p2) {
    H1 = informationContent(p1)$height
    H2 = informationContent(p2)$height
    obj=list();
    # if p is identical to q, set height to 0
    if(all(p1==p2)) {
        obj$height=0;   
    } else {
        obj$height=sum( abs(H1*p1 - H2*p2));
    }
    obj$ylab="Information Content [bits]";
    return(obj);
}

##' the change of information content for the given probability vectors
##'
##' @title the change of information content
##' @param p1 probability vector representing the first symbol distribution
##' @param p2 probability vector representing the second symbol distribution
##' @return an object consisting of height and ylab
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, stackHeight = lossOfAbsICDifferences)
lossOfAbsICDifferences = function(p1,p2) {
    H1 = informationContent(p1)$height
    H2 = informationContent(p2)$height
    obj=list();
    # if p is identical to q, set height to 0
    if(all(p1==p2)) {
        obj$height=0;   
    } else {
        obj$height=sum( abs(H1*p1 - H2*p2)) / (H1/2 + H2/2) * 100;
    }
    obj$ylab="Change of Information Content [%]";
    return(obj);
}

##' the shannon divergence for the given pair of probability vectors
##'
##' @title shannon divergence
##' @param p1 probability vector representing the first symbol distribution
##' @param p2 probability vector representing the second symbol distribution
##' @return an object consisting of height and ylab
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, stackHeight = shannonDivergence)
shannonDivergence = function(p1,p2) {
    obj=list();
    # if p is identical to q, set height to 0
    if(all(p1==p2)) {
        obj$height=0;   
    } else {
        m = (p1 + p2) / 2
        obj$height=0.5*sum( p1 * (log2(p1) - log2(m)),na.rm=TRUE) + 0.5*sum( p2 * (log2(p2) - log2(m)),na.rm=TRUE);
    }
    obj$ylab="JS divergence";
    return(obj);
}

##' the sum of probabilities for the given probability vector, i.e. 1.0
##'
##' @title sum of probabilities, i.e. 1.0
##' @param p probability vector representing the symbol distribution
##' @return an object consisting of height and ylab
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_name = "HepG2"
##' fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
##' file = system.file(fileName, package = "DiffLogo")
##' motif = getPwmFromPwmFile(file)
##' seqLogo(pwm = motif, stackHeight = sumProbabilities)
sumProbabilities = function (p) {
    obj=list();
    obj$height=sum(p);
    obj$ylab="Probability";
    return(obj);
}

##' the information content for the given probability vector
##'
##' @title information content
##' @param p probability vector representing the symbol distribution
##' @return an object consisting of height a ylab
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_name = "HepG2"
##' fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
##' file = system.file(fileName, package = "DiffLogo")
##' motif = getPwmFromPwmFile(file)
##' seqLogo(pwm = motif, stackHeight = informationContent)
informationContent = function (p) {
    obj=list();
    ic = log2(length(p)) + sum(p * log2(p),na.rm=TRUE);
    obj$height=ic;
    obj$ylab="Information Content [bits]";
    return(obj);
}

library(DiffLogo)
context("Stack Heights")

a=c(1,0,0,0)
b=c(0,1,0,0)
c=c(0.5,0.5,0,0)
d=c(0,0,0.5,0.5)
e=c(0,0.5,0.5,0)
f=c(.25,.25,.25,.25)
test_that("sumOfAbsProbabilityDifferences", {
   expect_equal(sumOfAbsProbabilityDifferences(a,a)$height, 0)
   expect_equal(sumOfAbsProbabilityDifferences(a,b)$height, 2)
   expect_equal(sumOfAbsProbabilityDifferences(b,a)$height, 2)
   expect_equal(sumOfAbsProbabilityDifferences(c,d)$height, 2)
   expect_equal(sumOfAbsProbabilityDifferences(d,c)$height, 2)
   expect_equal(sumOfAbsProbabilityDifferences(c,e)$height, 1)
   expect_equal(sumOfAbsProbabilityDifferences(e,c)$height, 1)
})

test_that("sumOfAbsICDifferences", {
   expect_equal(sumOfAbsICDifferences(a,a)$height, 0)
   expect_equal(sumOfAbsICDifferences(a,b)$height, 4)
   expect_equal(sumOfAbsICDifferences(b,a)$height, 4)
   expect_equal(sumOfAbsICDifferences(c,d)$height, 2)
   expect_equal(sumOfAbsICDifferences(d,c)$height, 2)
   expect_equal(sumOfAbsICDifferences(c,e)$height, 1)
   expect_equal(sumOfAbsICDifferences(e,c)$height, 1)
})

test_that("lossOfAbsICDifferences", {
   expect_equal(lossOfAbsICDifferences(a,a)$height, 0)
   expect_equal(lossOfAbsICDifferences(a,b)$height, 200)
   expect_equal(lossOfAbsICDifferences(b,a)$height, 200)
   expect_equal(lossOfAbsICDifferences(c,d)$height, 200)
   expect_equal(lossOfAbsICDifferences(d,c)$height, 200)
   expect_equal(lossOfAbsICDifferences(c,e)$height, 100)
   expect_equal(lossOfAbsICDifferences(e,c)$height, 100)
})

test_that("shannonDivergence", {
   expect_equal(shannonDivergence(a,a)$height, 0)
   expect_equal(shannonDivergence(a,b)$height, 1)
   expect_equal(shannonDivergence(b,a)$height, 1)
   expect_equal(shannonDivergence(c,d)$height, 1)
   expect_equal(shannonDivergence(d,c)$height, 1)
   expect_equal(shannonDivergence(c,e)$height, 0.5)
   expect_equal(shannonDivergence(e,c)$height, 0.5)
})

test_that("informationContent", {
       expect_equal(informationContent(a)$height, 2)
       expect_equal(informationContent(c)$height, 1)
       expect_equal(informationContent(f)$height, 0)
})
  

##' Creates a DiffLogo object
##'
##' @title DiffLogo object
##' @param pwm1 representation of the first position weight matrix (PWM) of type pwm, data.frame, or matrix
##' @param pwm2 representation of the second position weight matrix (PWM) of type pwm, data.frame, or matrix
##' @param stackHeight function for the height of a stack at position i
##' @param baseDistribution function for the heights of the individual bases
##' @param alphabet of type Alphabet
##' @param align_pwms if True, will aling and extend pwms.
##' @param unaligned_penalty is a function for localPwmAlignment.
##' @param try_reverse_complement if True, alignment will try reverse complement pwms
##' @param base_distribution is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @param length_normalization If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.
##' @param unaligned_from_left the number of unaligned positions on the left
##' @param unaligned_from_right the number of unaligned positions on the right
##' @return DiffLogo object
##' @export
##' @exportClass DiffLogo
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##'
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##'
##' diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
##' diffLogo(diffLogoObj)
createDiffLogoObject = function (pwm1, pwm2, 
                                 stackHeight=shannonDivergence,
                                 baseDistribution= normalizedDifferenceOfProbabilities,
                                 alphabet=DNA, align_pwms=FALSE,
                                 unaligned_penalty=divergencePenaltyForUnaligned,
                                 try_reverse_complement=TRUE,
                                 base_distribution=NULL,
                                 length_normalization = FALSE,
                                 unaligned_from_left = 0,
                                 unaligned_from_right = 0) {
    pwm1 = preconditionTransformPWM(pwm1,alphabet);
    pwm2 = preconditionTransformPWM(pwm2,alphabet);
    preconditionPWM(pwm1);
    preconditionPWM(pwm2);
    if (align_pwms) {
        alignment = localPwmAlignment(
            pwm1, pwm2,
            divergence = stackHeight,
            unaligned_penalty = unaligned_penalty,
            try_reverse_complement = try_reverse_complement && alphabet$supportReverseComplement,
            base_distribution = base_distribution,
            length_normalization = length_normalization);
        aligned_extended_pwms = extendPwmsFromAlignmentVector(list(pwm1, pwm2), alignment$vector, base_distribution);        
        unaligned_from_left = max(alignment$vector[[1]]$shift, alignment$vector[[2]]$shift);
        alignment_length = max(alignment$vector[[1]]$shift+ncol(pwm1), alignment$vector[[2]]$shift+ncol(pwm2));
        unaligned_from_right = max( alignment_length-ncol(pwm1)-alignment$vector[[1]]$shift, alignment_length-ncol(pwm2)-alignment$vector[[2]]$shift);

        pwm1 = aligned_extended_pwms[[1]]
        pwm2 = aligned_extended_pwms[[2]]
    }
    preconditionPWMSameSize(pwm1,pwm2);


    # init needed variables
    letters = list(x = NULL, y = NULL, id = NULL, fill = NULL)
    npos = ncol(pwm1)
    ylim.negMax = 0;
    ylim.posMax = 0;

    npos = ncol(pwm1)
    wt = 1.0 # the width of one letter
    x.pos = 0.5 + unaligned_from_left # initial position on x axis is 0.5; Letter is one right from this point
    heights = rep(0,npos); ymins=rep(0,npos); ymaxs=rep(0,npos); 

    for (j in (unaligned_from_left+1):(npos - unaligned_from_right)) {
        heightObj = stackHeight(pwm1[,j],pwm2[,j]);

        preconditionStackHeight(heightObj); # check for correctness
        heights[j] = heightObj$height;
        ylab = heightObj$ylab;

        distr = baseDistribution(pwm1[,j],pwm2[,j]);
        preconditionBaseDistribution(distr); # check for correctness

        hts = distr*heights[j];
        letterOrder = order(abs(hts)) # reorder letters
        
        yneg.pos = 0
        ypos.pos = 0
        
        # adds all letters as polygons to the list of letters
        for (i in 1:length(hts)) {
            ht = hts[letterOrder[i]]
            ht_total = sum(hts);
            if (ht >= 0){
                y.pos = ypos.pos;
                ypos.pos = ypos.pos + ht
            } else if(ht < 0 ) {
                y.pos = yneg.pos;
                yneg.pos = yneg.pos + ht
            }
            char = alphabet$chars[ (letterOrder[i]-1)%%alphabet$size+1 ]
            col = alphabet$cols[ (letterOrder[i]-1)%%alphabet$size+1 ];
            letters = addLetter(letters, letterPolygons[[char]], x.pos, y.pos, ht, wt*0.99, col=col)
        }

        x.pos = x.pos + wt
        ylim.negMax = min(ylim.negMax, yneg.pos)
        ylim.posMax = max(ylim.posMax, ypos.pos)
        # remember values for plotting
        ymins[j] = yneg.pos
        ymaxs[j] = ypos.pos
    }

    diffObj = list();
    diffObj$ylab=ylab; # should be set by the stackHeight function
    diffObj$npos = npos;
    diffObj$heights = heights;
    diffObj$ymins = ymins
    diffObj$ymaxs = ymaxs
    diffObj$ylim.negMax = ylim.negMax
    diffObj$ylim.posMax = ylim.posMax
    diffObj$letters = letters;
    diffObj$pwm1 = pwm1
    diffObj$pwm2 = pwm2
    diffObj$distance = sum(abs(heights)) # TODO as function
    diffObj$alphabet = alphabet
    diffObj$unaligned_from_left = unaligned_from_left
    diffObj$unaligned_from_right = unaligned_from_right
    class(diffObj) = "DiffLogo"
    return(diffObj);
}

##' Draws the difference of two sequence logos.
##'
##' @title Draw DiffLogo
##' @param diffLogoObj a DiffLogoObject created by the function createDiffLogoObject
##' @param ymin minimum value on the y-axis
##' @param ymax maximum value on the y-axis
##' @param sparse if TRUE margins are reduced and tickmarks are removed from the logo
##' @param diffLogoConfiguration list of configuration parameters (see function diffLogoTableConfiguration(...))
##' @return none (draws difference logo)
##' @export
##' @importFrom graphics plot axis polygon rect text lines
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##'
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##'
##' diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
##' diffLogo(diffLogoObj)
diffLogo = function (diffLogoObj, ymin=0, ymax=0, sparse=FALSE, diffLogoConfiguration = list()) {
    if(!is(diffLogoObj, "DiffLogo")) {
        msg = paste("Expected DiffLogo, but got ", class(diffLogoObj), ". Use #createDiffLogoObject to get an DiffLogo from two PWMs.",sep="")
        stop(msg)
    }

    if(ymin == 0) {
        ymin = diffLogoObj$ylim.posMax
    }
    if(ymax == 0) {
        ymax = diffLogoObj$ylim.negMax
    }

    # set ylab
    ylab = diffLogoObj$ylab

    if(sparse) {
        # the sparse plot has small ticks, small y-labels, no x-labels, no xlab, no ylab
        plot(NA, xlim=c(0.5,diffLogoObj$npos + 0.5), ylim=c(ymin,ymax), xaxt="n", ylab="", mgp=c(0, .35, 0), tck=-0.02, cex.axis=0.8, frame.plot=FALSE,xlab="")
    } else {
        plot(NA, xlim=c(0.5,diffLogoObj$npos + 0.5), ylim=c(ymin,ymax), xaxt="n", ylab=ylab, xlab="Position", frame.plot=FALSE, )
    }

    if(sparse) {
        axis(1,labels=c(rep("",diffLogoObj$npos)), at=(1:diffLogoObj$npos),tck=-0.02)
        axis(1,labels=c("",""), at=c(0,(diffLogoObj$npos+1)),tck=-0.00)
    } else {
        axis(1,labels=c(1:diffLogoObj$npos),at=(1:diffLogoObj$npos))
        axis(1,labels=c("",""), at=c(0,(diffLogoObj$npos+1)),tck=-0.00)
    }
    polygon(diffLogoObj$letters, col=diffLogoObj$letters$col, border=FALSE)
    if (!is.null(diffLogoObj$unaligned_from_left) && diffLogoObj$unaligned_from_left>0) {
        rect(0.5, -ymin, diffLogoObj$unaligned_from_left+0.5, -ymax, col="gray", border="gray")
    }

    if (!is.null(diffLogoObj$unaligned_from_right) && diffLogoObj$unaligned_from_right>0) {
        rect(diffLogoObj$npos-diffLogoObj$unaligned_from_right+0.5, -ymin, diffLogoObj$npos+0.5, -ymax, col="gray", border="gray")
    }

    if(!is.null(diffLogoObj$pvals)) {
        leftOffset = 0;
        if(!is.null(diffLogoObj$unaligned_from_left)) {
            leftOffset = diffLogoObj$unaligned_from_left;
        }
        if(!is.null(diffLogoObj$unaligned_from_right)) {
            rightOffset = diffLogoObj$unaligned_from_right;
        }
        npos = ncol(diffLogoObj$pwm1);
        for (j in (leftOffset+1):(npos - rightOffset)) {
            if( diffLogoObj$pvals[j] < 0.05  ) {
                text(j, ymin, "*");
            }
        }
    }
    
    lines(c(0,diffLogoObj$npos), c(0,0) ) # the line at y = 0
}

##' Draws the difference of two sequence logos.
##'
##' @title Draw DiffLogo from PWM
##' @param pwm1 representation of the first position weight matrix (PWM) of type pwm, data.frame, or matrix
##' @param pwm2 representation of the second position weight matrix (PWM) of type pwm, data.frame, or matrix
##' @param ymin minimum value on the y-axis
##' @param ymax maximum value on the y-axis
##' @param stackHeight function for the height of a stack at position i
##' @param baseDistribution function for the heights of the individual bases
##' @param sparse if TRUE margins are reduced and tickmarks are removed from the logo
##' @param alphabet of type Alphabet
##' @param align_pwms if true, DiffLogo will align pwms before plotting
##' @param unaligned_penalty is a function for localPwmAlignment.
##' @param try_reverse_complement if True, alignment will try reverse complement pwms
##' @param base_distribution is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used
##' @param length_normalization If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.
##' @return none (draws difference logo)
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' 
##' pwm1 = motifs[[motif_names[[1]]]]
##' pwm2 = motifs[[motif_names[[2]]]]
##' 
##' diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2)
diffLogoFromPwm = function (
                      pwm1, pwm2, ymin=0, ymax=0,
                      stackHeight=shannonDivergence,
                      baseDistribution=normalizedDifferenceOfProbabilities,
                      sparse=FALSE, alphabet=DNA, align_pwms=FALSE,
                      unaligned_penalty=divergencePenaltyForUnaligned,
                      try_reverse_complement=TRUE, base_distribution=NULL,
                      length_normalization = FALSE) {
    diffLogoObj = createDiffLogoObject(
                      pwm1, pwm2, stackHeight=stackHeight,
                      baseDistribution=baseDistribution,
                      alphabet=alphabet,
                      align_pwms=align_pwms,
                      unaligned_penalty=unaligned_penalty,
                      try_reverse_complement=try_reverse_complement,
                      base_distribution=NULL, length_normalization = length_normalization);
    diffLogo(diffLogoObj, ymin=ymin, ymax=ymax, sparse=sparse)
}

##' Prepares a DiffLogoTable and generates an object that contains the hirarchical clustering and a matrix of prepared difference logos. 
##'
##' @title Prepare a table of difflogo objects
##' @param PWMs a list/vector of position weight matrices (PWMs) each of type pwm, data.frame, or matrix
##' @param alphabet the alphabet of the given PWMs
##' @param configuration list of (probably part of) of configuration options. See diffLogoTableConfiguration.
##' @return matrix of difference logos
##' @importFrom utils modifyList
##' @importFrom stats dist
##' @importFrom stats hclust
##' @export
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##' sampleSizes <- c(100, 150, 200, 250)
##' 
##' diffLogoTableObj = prepareDiffLogoTable(motifs);
prepareDiffLogoTable = function (
            PWMs,
            alphabet=DNA,
            configuration=list()
) {
    configuration        = modifyList(diffLogoTableConfiguration(alphabet), configuration)
    enableClustering     = configuration$enableClustering
    stackHeight            = configuration$stackHeight
    baseDistribution       = configuration$baseDistribution
    multiple_align_pwms    = configuration$multiple_align_pwms
    align_pwms             = configuration$align_pwms
    unaligned_penalty      = configuration$unaligned_penalty;
    try_reverse_complement = (configuration$try_reverse_complement && alphabet$supportReverseComplement)
    length_normalization   = configuration$length_normalization
    numberOfPermutations   = configuration$numberOfPermutations
    dim = length(PWMs);
    similarities = matrix(0,dim,dim);
    names = extractNames(PWMs);
    diffLogoTableObj = list();
    for ( i in 1:dim) {
        PWMs[[names[i]]] = preconditionTransformPWM(PWMs[[names[i]]],alphabet);
    }

    if (multiple_align_pwms) {
        multiple_pwms_alignment = multipleLocalPwmsAlignment(PWMs, try_reverse_complement = try_reverse_complement);
        originalPwmLengths = lapply(PWMs, ncol);
        PWMs = extendPwmsFromAlignmentVector( PWMs, multiple_pwms_alignment$alignment$vector);
        stopifnot(dim==length(PWMs))
        align_pwms = FALSE
    }
    
    diffLogoObjMatrix = list();
    for ( i in 1:dim) {
        motif_i = names[i];
        diffLogoObjMatrix[[ motif_i ]] = list()

        # alignment size in columns is always equal
        alignment_length = ncol(PWMs[[motif_i]]);

        for ( k in 1:dim) {
            if( i != k ) {
                motif_k = names[k];
            
                unaligned_from_left = 0
                unaligned_from_right = 0
                if (multiple_align_pwms) {
                    # the number of unaligned left positions is the maximum of the two shifts of the motifs
                    unaligned_from_left = max( multiple_pwms_alignment$alignment$vector[[i]]$shift,
                                               multiple_pwms_alignment$alignment$vector[[k]]$shift)
                    
                    # the number of unaligned right positions is the length of the alignment minus the orignal pwm length
                    rightShiftMotif_i = alignment_length - originalPwmLengths[[ motif_i ]] - multiple_pwms_alignment$alignment$vector[[i]]$shift;
                    rightShiftMotif_k = alignment_length - originalPwmLengths[[ motif_k ]] - multiple_pwms_alignment$alignment$vector[[k]]$shift;
                    unaligned_from_right = max(rightShiftMotif_i, rightShiftMotif_k)
                }
                diffLogoObjMatrix[[motif_i]][[motif_k]] = 
                        createDiffLogoObject(  PWMs[[ motif_i ]],
                                               PWMs[[ motif_k ]],
                                               stackHeight = stackHeight,
                                               baseDistribution = baseDistribution,
                                               alphabet = alphabet,
                                               align_pwms = align_pwms,
                                               unaligned_penalty = unaligned_penalty,
                                               try_reverse_complement = try_reverse_complement,
                                               length_normalization = length_normalization,
                                               unaligned_from_left = unaligned_from_left,
                                               unaligned_from_right = unaligned_from_right);
                similarities[i, k] = diffLogoObjMatrix[[motif_i]][[motif_k]]$distance;
                similarities[k, i] = diffLogoObjMatrix[[motif_i]][[motif_k]]$distance;
            } 
        }
    }

    leafOrder=1:dim;
    if(enableClustering) {
        distance = dist(similarities);
        hc = hclust(distance, "average");
        opt = order.optimal(distance,hc$merge);
        hc$merge=opt$merge;
        hc$order=opt$order;

        diffLogoTableObj$hc = hc;
        leafOrder = diffLogoTableObj$hc$order;
    }
    
    diffLogoTableObj$diffLogoObjMatrix = diffLogoObjMatrix;
    diffLogoTableObj$PWMs = PWMs;
    diffLogoTableObj$leafOrder = leafOrder;
    diffLogoTableObj$configuration = configuration;
    diffLogoTableObj$alphabet = alphabet;
    return (diffLogoTableObj);
}

##' Draws a table of DiffLogos.
##'
##' @title Draws a table of DiffLogos
##' @param diffLogoTableObj the diffLogoTable-Object created by function prepareDiffLogoTable(...)
##' @param ... optional parameters for functon axis
##' @return none (draws difference logo)
##' @importFrom grDevices colorRampPalette rgb
##' @importFrom graphics plot.new par plot rect axis
##' @export
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##'
##' diffLogoTableObj = prepareDiffLogoTable(motifs)
##' drawDiffLogoTable(diffLogoTableObj)
drawDiffLogoTable = function (
            diffLogoTableObj,
            ...
) {
    alphabet             = diffLogoTableObj$alphabet
    configuration        = diffLogoTableObj$configuration
    enableClustering     = configuration$enableClustering
    uniformYaxis         = configuration$uniformYaxis
    sparse               = configuration$sparse
    showSequenceLogosTop = configuration$showSequenceLogosTop
    treeHeight           = configuration$treeHeight
    margin               = configuration$margin
    ratio                = configuration$ratio

    PWMs = diffLogoTableObj$PWMs;
    diffLogoObjMatrix = diffLogoTableObj[['diffLogoObjMatrix']];

    marDiffLogo = getMarginsSeqLogo(sparse);
    marSeqLogo = getMarginsSeqLogo(sparse);
    ymin = 0; ymax = 0;
    if( !enableClustering ) {
        treeHeight=0;
    }
    st = 0;
    if(showSequenceLogosTop) {
        st = 0.5;
    }
    orderedMotifs = names(diffLogoObjMatrix)[diffLogoTableObj$leafOrder];
    
    dim = length(orderedMotifs);
    similarities = matrix(0,dim,dim);

    # Filling similarity matrix and computing y axes limits.
    # The order of motifs in diffLogoObjMatrix is the same as in orderedMotifs
    for ( i in 1:dim) {
        for ( k in 1:dim) {
            motif_i = orderedMotifs[i];
            motif_k = orderedMotifs[k];
            if(!is.null(diffLogoObjMatrix[[motif_i]][[motif_k]])) { 
                similarities[i,k] = diffLogoObjMatrix[[motif_i]][[motif_k]]$distance;
            } else {
                similarities[i,k]  = 0;
            }
            if(uniformYaxis) {
                ymin = min(diffLogoObjMatrix[[motif_i]][[motif_k]]$ylim.negMax, ymin)
                ymax = max(diffLogoObjMatrix[[motif_i]][[motif_k]]$ylim.posMax, ymax)
            }
        }
    }
    palette = colorRampPalette(c(rgb(0.9,1,0.9),rgb(1,0.9,0.9)))(100)
    colors = matrix(palette[cut(similarities,100)],dim,dim)

    # drawing the matrix of DiffLogos
    plot.new();
    dimV = c(dim, dim, dim + st + treeHeight, dim + st + treeHeight);
    for ( i in 1:dim) {
        for ( k in 1:dim) {
            motif_i = orderedMotifs[i];
            motif_k = orderedMotifs[k];
            if(!is.null(diffLogoObjMatrix[[motif_i]][[motif_k]])) { 
                subplotcoords = c(i-1,i,dim-k,dim-k+1)

                par(fig=(subplotcoords / dimV) * c(1-margin,1-margin,1-margin*ratio,1-margin*ratio) + c(margin,margin,0,0), new=TRUE, mar=c(0,0,0,0))

                plot(NA,ylim=c(0,1),xlim=c(0,1),xaxt="n",yaxt="n",xaxs="i",yaxs="i",bty="n")
                rect(0,0,1,1,col=colors[i,k],border=NA);

                par(fig=(subplotcoords / dimV) * c(1-margin,1-margin,1-margin*ratio,1-margin*ratio) + c(margin,margin,0,0), new=TRUE, mar=marDiffLogo)

                diffLogo(diffLogoObjMatrix[[motif_i]][[motif_k]], sparse=sparse, ymin=ymin, ymax=ymax);
            }
        }
    }
                
    # draw sequence logos
    if(showSequenceLogosTop) {
        for(i in 1:dim) {
            subplotcoords = c(i-1, i, dim, dim + st)
            par(fig=(subplotcoords / dimV) * c(1-margin,1-margin,1-margin*ratio,1-margin*ratio) + c(margin,margin,margin*ratio,margin*ratio), new=TRUE, mar=marSeqLogo)
            seqLogo(PWMs[[  orderedMotifs[i] ]],sparse=sparse, alphabet=alphabet)
        }
    }

    # draw cluster tree
    if(treeHeight > 0 && enableClustering) {
        par(fig=c(0 + 0.5, dim - 0.5, dim + st, dim + st + treeHeight) / dimV * c(1-margin,1-margin,1-margin*ratio,1-margin*ratio) + c(margin,margin,margin*ratio,margin*ratio), new=TRUE, mar=c(.0,.0,.1,.0))
        plot(diffLogoTableObj$hc, xaxt="n",yaxt="n",xaxs="i",yaxs="i",bty="n", labels=rep("",dim), main="" )
    }

    # add names
    par(fig=(c(0,dim,0,dim) / dimV) * c(1-margin,1-margin,1-margin*ratio,1-margin*ratio)+ c(margin,margin,0,0), new=TRUE, mar=c(0,0,0,0))

    plot(NA,ylim=c(0,dim),xlim=c(0,dim),xaxs="i",xaxt="n",yaxt="n",yaxs="i", bty="n", mar=c(0,0,0,0))
    axis(2, pos=0, at= (1:dim) - 0.5, labels = rev(orderedMotifs), tick = FALSE, mgp = c(3, 0, 0), ...)
    axis(3, pos=dim, at= (1:dim) - 0.5, labels = orderedMotifs, tick = FALSE, mgp = c(3, 0, 0), ...)
}

##' Draws a table of DiffLogos.
##'
##' @title Draw DiffLogo-table
##' @param PWMs a list/vector of position weight matrices (PWMs) each of type pwm, data.frame, or matrix
##' @param sampleSizes the number of sequences behind each PWM
##' @param alphabet the alphabet of the given PWMs
##' @param configuration list of (probably part of) of configuration options. See diffLogoTableConfiguration.
##' @param ... set of parameters passed to the function 'axis' for plotting
##' @return none (draws table of difference logos)
##' @export
##' @importFrom cba order.optimal
##' @importFrom utils modifyList
##' @author Martin Nettling
##' @examples
##' motif_folder= "extdata/pwm"
##' motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
##' motifs = list()
##' for (name in motif_names) {
##'   fileName = paste(motif_folder,"/",name,".pwm",sep="")
##'   file = system.file(fileName, package = "DiffLogo")
##'   motifs[[name]] = getPwmFromPwmFile(file)
##' }
##'
##' diffLogoTable(motifs)
diffLogoTable = function (
            PWMs,
            sampleSizes=NULL,
            alphabet=DNA,
            configuration=list(),
            ...
) {
    if(sum(names(configuration) %in% names(diffLogoTableConfiguration(alphabet))) != length(configuration)) {
        stop(paste("Unknown arguments passed to diffLogoTable:",  paste(names(configuration[ !(names(configuration) %in% names(diffLogoTableConfiguration(alphabet)))]), sep=",")))
    }
    if(is.null(names(PWMs))) {
      names(PWMs) = sapply((1:length(PWMs)), toString)
    }
    
    configuration        = modifyList(diffLogoTableConfiguration(alphabet), configuration)
    diffLogoTableObj = prepareDiffLogoTable(PWMs, alphabet, configuration, ...);
    
    if(!is.null(sampleSizes)) {
      diffLogoTableObj$diffLogoObjMatrix = enrichDiffLogoTableWithPvalues(diffLogoTableObj$diffLogoObjMatrix, sampleSizes, configuration$stackHeight, configuration$numberOfPermutations)
    }
    drawDiffLogoTable(diffLogoTableObj, ... );
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alphabet.R
\docType{data}
\name{RNA}
\alias{RNA}
\title{RNA alphabet}
\format{An object of class \code{Alphabet} of length 4.}
\usage{
RNA
}
\description{
the RNA alphabet, i.e. A, C, G, U
}
\examples{
RNA
}
\author{
Martin Nettling
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/baseDistrs.R
\name{normalizedDifferenceOfProbabilities}
\alias{normalizedDifferenceOfProbabilities}
\title{normalized probability differences}
\usage{
normalizedDifferenceOfProbabilities(p1, p2)
}
\arguments{
\item{p1}{probability vector representing the first symbol distribution}

\item{p2}{probability vector representing the second symbol distribution}
}
\value{
a vector with one result for each symbol
}
\description{
probability differences normalized by the sum of absolute probability differences for the given pair of probability vectors
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

pwm1 = motifs[[motif_names[[1]]]]
pwm2 = motifs[[motif_names[[2]]]]

diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2, baseDistribution = normalizedDifferenceOfProbabilities)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogoSupport.R
\name{calculatePvalue}
\alias{calculatePvalue}
\title{p-value that two PWM-positions are from the same distribution}
\usage{
calculatePvalue(p1, p2, n1, n2, stackHeight = shannonDivergence,
  numberOfPermutations = 100, plotGammaDistributionFit = FALSE)
}
\arguments{
\item{p1}{first probability vector with one probability for each symbol of the alphabet}

\item{p2}{second probability vector with one probability for each symbol of the alphabet}

\item{n1}{number of observations for the calculation of p1}

\item{n2}{number of observations for the calculation of p2}

\item{stackHeight}{function for the calculation of a divergence measure for two probability vectors}

\item{numberOfPermutations}{the number of permutations to perform for the calculation of stackHeights}

\item{plotGammaDistributionFit}{if TRUE the fit of a gamma distribution to the sampled stackHeights is plotted}
}
\value{
a numeric p-value
}
\description{
Calculates the p-value for the null-hypothesis that two given probability vectors p1, p2 calculated from n1/n2 observations arise from the same distribution
}
\examples{
p1 <- c(0.2, 0.3, 0.1, 0.4)
p2 <- c(0.2, 0.1, 0.3, 0.4)
n1 <- 100
n2 <- 200
numberOfPermutations = 100
plotGammaDistributionFit = TRUE

pValue <- calculatePvalue(p1 = p1, p2 = p2, n1 = n1, n2 = n2, stackHeight = shannonDivergence, numberOfPermutations = numberOfPermutations, plotGammaDistributionFit = plotGammaDistributionFit)
}
\author{
Hendrik Treutler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/baseDistrs.R
\name{probabilities}
\alias{probabilities}
\title{probabilities}
\usage{
probabilities(p)
}
\arguments{
\item{p}{probability vector representing the symbol distribution}
}
\value{
the given vector
}
\description{
the given probabilities
}
\examples{
motif_folder= "extdata/pwm"
motif_name = "HepG2"
fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
file = system.file(fileName, package = "DiffLogo")
motif = getPwmFromPwmFile(file)
seqLogo(pwm = motif, baseDistribution = probabilities)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alphabet.R
\docType{data}
\name{DNA}
\alias{DNA}
\title{DNA alphabet}
\format{An object of class \code{Alphabet} of length 4.}
\usage{
DNA
}
\description{
the DNA alphabet, i.e. A, C, G, T
}
\examples{
DNA
}
\author{
Martin Nettling
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getSequencesFromAlignmentFile}
\alias{getSequencesFromAlignmentFile}
\title{extracts the sequences from an alignment file}
\usage{
getSequencesFromAlignmentFile(filename)
}
\arguments{
\item{filename}{the alignment file}
}
\value{
a vector of sequences
}
\description{
extracts the sequences from an alignment file
}
\examples{
fileName = "extdata/alignments/calamodulin_1.txt"
file = system.file(fileName, package = "DiffLogo")
sequences = getSequencesFromAlignmentFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogoSupport.R
\name{enrichDiffLogoObjectWithPvalues}
\alias{enrichDiffLogoObjectWithPvalues}
\title{Enriches a difflogo object with p-values}
\usage{
enrichDiffLogoObjectWithPvalues(diffLogoObj, n1, n2,
  stackHeight = shannonDivergence, numberOfPermutations = 100)
}
\arguments{
\item{diffLogoObj}{matrix of difflogo objects}

\item{n1}{the number of sequences behind the first pwm behind the given difflogo object}

\item{n2}{the number of sequences behind the second pwm behind the given difflogo object}

\item{stackHeight}{function for the calculation of a divergence measure for two probability vectors}

\item{numberOfPermutations}{the number of permutations to perform for the calculation of stackHeights}
}
\value{
enriched difflogo object
}
\description{
Enriches a difflogo object with p-values which quantifies the probability that two PWM-positions are from the same distribution
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

pwm1 = motifs[[motif_names[[1]]]]
pwm2 = motifs[[motif_names[[2]]]]
n1 <- 100
n2 <- 100
diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
diffLogoObj = enrichDiffLogoObjectWithPvalues(diffLogoObj, n1, n2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogo.R
\name{drawDiffLogoTable}
\alias{drawDiffLogoTable}
\title{Draws a table of DiffLogos}
\usage{
drawDiffLogoTable(diffLogoTableObj, ...)
}
\arguments{
\item{diffLogoTableObj}{the diffLogoTable-Object created by function prepareDiffLogoTable(...)}

\item{...}{optional parameters for functon axis}
}
\value{
none (draws difference logo)
}
\description{
Draws a table of DiffLogos.
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

diffLogoTableObj = prepareDiffLogoTable(motifs)
drawDiffLogoTable(diffLogoTableObj)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{reverseAlignmentVector}
\alias{reverseAlignmentVector}
\title{Reverse for alignment vector}
\usage{
reverseAlignmentVector(alignment_vector, pwms)
}
\arguments{
\item{alignment_vector}{list of list which $shift and $orientation}

\item{pwms}{list of matrixes.}
}
\value{
list - reversed alignment vector
}
\description{
Returns alignment vector as if all pwm were reverted.
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{extendPwmsFromAlignmentVector}
\alias{extendPwmsFromAlignmentVector}
\title{Extend pwms with respect to alignment}
\usage{
extendPwmsFromAlignmentVector(pwms, alignment_vector,
  base_distribution = NULL)
}
\arguments{
\item{pwms}{is a list of matrixes}

\item{alignment_vector}{is a list of shifts ($shift) and orientations ($direction)}

\item{base_distribution}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}
}
\value{
extended pwms
}
\description{
Extends pwms by adding base_distribution to both sides, so that they keep aligned, but have equal length.
}
\examples{
file1 = system.file("extdata/homer/Max.motif",   package = "DiffLogo")
file2 = system.file("extdata/homer/c-Myc.motif", package = "DiffLogo")
pwm1 = getPwmFromFile(file1)
pwm2 = getPwmFromFile(file2)

pwms <- list(pwm1, pwm2)
multiple_pwms_alignment = multipleLocalPwmsAlignment(pwms)
aligned_pwms = extendPwmsFromAlignmentVector(pwms, multiple_pwms_alignment$alignment$vector)
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogo.R
\name{prepareDiffLogoTable}
\alias{prepareDiffLogoTable}
\title{Prepare a table of difflogo objects}
\usage{
prepareDiffLogoTable(PWMs, alphabet = DNA, configuration = list())
}
\arguments{
\item{PWMs}{a list/vector of position weight matrices (PWMs) each of type pwm, data.frame, or matrix}

\item{alphabet}{the alphabet of the given PWMs}

\item{configuration}{list of (probably part of) of configuration options. See diffLogoTableConfiguration.}
}
\value{
matrix of difference logos
}
\description{
Prepares a DiffLogoTable and generates an object that contains the hirarchical clustering and a matrix of prepared difference logos.
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}
sampleSizes <- c(100, 150, 200, 250)

diffLogoTableObj = prepareDiffLogoTable(motifs);
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{alignPwmSets}
\alias{alignPwmSets}
\title{Multiple PWMs alignment}
\usage{
alignPwmSets(left_pwms_set, left_alignment, right_pwms_set,
  right_alignment, try_reverse_complement)
}
\arguments{
\item{left_pwms_set}{list of pwms(matrixes)}

\item{left_alignment}{alignment of left_pwms_set.}

\item{right_pwms_set}{list of pwms;}

\item{right_alignment}{alignment of right_pwms_set.}

\item{try_reverse_complement}{if true(default), also try reverse complement.}
}
\value{
list - alignment of concatination of left_pwms_set and right_pwms_set
}
\description{
Align two sets of pwms
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogo.R
\name{diffLogoFromPwm}
\alias{diffLogoFromPwm}
\title{Draw DiffLogo from PWM}
\usage{
diffLogoFromPwm(pwm1, pwm2, ymin = 0, ymax = 0,
  stackHeight = shannonDivergence,
  baseDistribution = normalizedDifferenceOfProbabilities,
  sparse = FALSE, alphabet = DNA, align_pwms = FALSE,
  unaligned_penalty = divergencePenaltyForUnaligned,
  try_reverse_complement = TRUE, base_distribution = NULL,
  length_normalization = FALSE)
}
\arguments{
\item{pwm1}{representation of the first position weight matrix (PWM) of type pwm, data.frame, or matrix}

\item{pwm2}{representation of the second position weight matrix (PWM) of type pwm, data.frame, or matrix}

\item{ymin}{minimum value on the y-axis}

\item{ymax}{maximum value on the y-axis}

\item{stackHeight}{function for the height of a stack at position i}

\item{baseDistribution}{function for the heights of the individual bases}

\item{sparse}{if TRUE margins are reduced and tickmarks are removed from the logo}

\item{alphabet}{of type Alphabet}

\item{align_pwms}{if true, DiffLogo will align pwms before plotting}

\item{unaligned_penalty}{is a function for localPwmAlignment.}

\item{try_reverse_complement}{if True, alignment will try reverse complement pwms}

\item{base_distribution}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}

\item{length_normalization}{If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.}
}
\value{
none (draws difference logo)
}
\description{
Draws the difference of two sequence logos.
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

pwm1 = motifs[[motif_names[[1]]]]
pwm2 = motifs[[motif_names[[2]]]]

diffLogoFromPwm(pwm1 = pwm1, pwm2 = pwm2)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{multipleLocalPwmsAlignment}
\alias{multipleLocalPwmsAlignment}
\title{Multiple PWMs alignment}
\usage{
multipleLocalPwmsAlignment(pwms, divergence = shannonDivergence,
  unaligned_penalty = divergencePenaltyForUnaligned,
  try_reverse_complement = TRUE, base_distribution = NULL,
  length_normalization = FALSE)
}
\arguments{
\item{pwms}{list of pwms}

\item{divergence}{Divergence measure.}

\item{unaligned_penalty}{is a function for localPwmAlignment.}

\item{try_reverse_complement}{if True, alignment will try reverse complement pwms}

\item{base_distribution}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}

\item{length_normalization}{If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.}
}
\value{
list
}
\description{
Creates a multiple alignment of pwms
}
\examples{
file1 = system.file("extdata/homer/Max.motif",   package = "DiffLogo")
file2 = system.file("extdata/homer/c-Myc.motif", package = "DiffLogo")
pwm1 = getPwmFromFile(file1)
pwm2 = getPwmFromFile(file2)

multiple_pwms_alignment = multipleLocalPwmsAlignment(list(pwm1, pwm2))
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{normalizePWM}
\alias{normalizePWM}
\title{normalizes the given pwm}
\usage{
normalizePWM(pwm)
}
\arguments{
\item{pwm}{a pwm}
}
\value{
a normalized pwm
}
\description{
normalizes the given pwm to column-sums of 1.0
}
\examples{
pwm = matrix(1:40, nrow = 4, dimnames = list(c("A","C","G","T"), 1:10))
pwm = normalizePWM(pwm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{localPwmAlignment}
\alias{localPwmAlignment}
\title{Align pwms}
\usage{
localPwmAlignment(pwm_left, pwm_right, divergence = shannonDivergence,
  unaligned_penalty = divergencePenaltyForUnaligned,
  try_reverse_complement = TRUE, base_distribution = NULL,
  length_normalization = FALSE)
}
\arguments{
\item{pwm_left}{first PWM, a matrix of type matrix}

\item{pwm_right}{first PWM, a matrix of type matrix}

\item{divergence}{is a measure of difference between two pwm columns. Smaller is more similar. If you want to use non-uniform background distribution, provide your own function.}

\item{unaligned_penalty}{distance for unaligned columns at edges of matrixes. See divergencePenaltyForUnaligned as an example for providing your own function}

\item{try_reverse_complement}{If false the alignment will not be performed on reverse complements. If true, the input pwms should have column order of ACTG/ACGU.}

\item{base_distribution}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}

\item{length_normalization}{If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.}
}
\value{
list of length two containing the alignment and the divergence
}
\description{
Finds best local alignment for two PWMs.
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alphabet.R
\docType{data}
\name{ASN}
\alias{ASN}
\title{ASN alphabet}
\format{An object of class \code{Alphabet} of length 4.}
\usage{
ASN
}
\description{
the amino acid alphabet (20 symbols), i.e. A, C, D, E, F, G, H, I, K, L, M, N, P, Q, R, S, T, V, W, Y
}
\examples{
ASN
}
\author{
Martin Nettling
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogo.R
\name{diffLogo}
\alias{diffLogo}
\title{Draw DiffLogo}
\usage{
diffLogo(diffLogoObj, ymin = 0, ymax = 0, sparse = FALSE,
  diffLogoConfiguration = list())
}
\arguments{
\item{diffLogoObj}{a DiffLogoObject created by the function createDiffLogoObject}

\item{ymin}{minimum value on the y-axis}

\item{ymax}{maximum value on the y-axis}

\item{sparse}{if TRUE margins are reduced and tickmarks are removed from the logo}

\item{diffLogoConfiguration}{list of configuration parameters (see function diffLogoTableConfiguration(...))}
}
\value{
none (draws difference logo)
}
\description{
Draws the difference of two sequence logos.
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

pwm1 = motifs[[motif_names[[1]]]]
pwm2 = motifs[[motif_names[[2]]]]

diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
diffLogo(diffLogoObj)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogoSupport.R
\name{pwmDivergence}
\alias{pwmDivergence}
\title{PWM divergence}
\usage{
pwmDivergence(pwm_left, pwm_right, divergence = shannonDivergence)
}
\arguments{
\item{pwm_left}{is a PWM representation in type of matrix}

\item{pwm_right}{is a PWM representation in type of matrix. The result is symmetric on pwm_left and pwm_right}

\item{divergence}{is a Divergence function on columns.}
}
\value{
float - sum of divergences
}
\description{
Counts PWM divergence as sum of divergencies of their columns.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stackHeights.R
\name{informationContent}
\alias{informationContent}
\title{information content}
\usage{
informationContent(p)
}
\arguments{
\item{p}{probability vector representing the symbol distribution}
}
\value{
an object consisting of height a ylab
}
\description{
the information content for the given probability vector
}
\examples{
motif_folder= "extdata/pwm"
motif_name = "HepG2"
fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
file = system.file(fileName, package = "DiffLogo")
motif = getPwmFromPwmFile(file)
seqLogo(pwm = motif, stackHeight = informationContent)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogoSupport.R
\name{enrichDiffLogoTableWithPvalues}
\alias{enrichDiffLogoTableWithPvalues}
\title{Enriches a matrix of difflogo objects with p-values}
\usage{
enrichDiffLogoTableWithPvalues(diffLogoObjMatrix, sampleSizes,
  stackHeight = shannonDivergence, numberOfPermutations = 100)
}
\arguments{
\item{diffLogoObjMatrix}{matrix of difflogo objects}

\item{sampleSizes}{number of sequences behind the pwms behind the given difflogo objects}

\item{stackHeight}{function for the calculation of a divergence measure for two probability vectors}

\item{numberOfPermutations}{the number of permutations to perform for the calculation of stackHeights}
}
\value{
matrix of difflogo objects enriched with p-values
}
\description{
Enriches a matrix of difflogo objects with p-values which quantifies the probability that two PWM-positions are from the same distribution
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}
sampleSizes <- c(100, 150, 200, 250)
names(sampleSizes) <- motif_names

diffLogoTableObj = prepareDiffLogoTable(motifs);
diffLogoTableObj$diffLogoObjMatrix = enrichDiffLogoTableWithPvalues(diffLogoTableObj$diffLogoObjMatrix, sampleSizes)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{twoSetsAveragePwmDivergenceFromAlignmentVector}
\alias{twoSetsAveragePwmDivergenceFromAlignmentVector}
\title{Average divergence between two sets.}
\usage{
twoSetsAveragePwmDivergenceFromAlignmentVector(left_pwms_list,
  left_pwms_alignment, right_pwms_list, right_pwms_alignment,
  divergence = shannonDivergence)
}
\arguments{
\item{left_pwms_list}{is a list of matrixes}

\item{left_pwms_alignment}{is a list of shifts ($shift) and orientations ($direction)}

\item{right_pwms_list}{is a list of matrixes}

\item{right_pwms_alignment}{is a list of shifts ($shift) and orientations ($direction)}

\item{divergence}{divergence measure.}
}
\value{
float
}
\description{
Computes average pwm divergence from alignment vector for two datasets. This equals to average divergence between all pairs where one pwm comes from left set, and other comes from right
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getAlphabetFromSequences}
\alias{getAlphabetFromSequences}
\title{returns the alphabet which fits to the given sequences}
\usage{
getAlphabetFromSequences(sequences)
}
\arguments{
\item{sequences}{a character vector of sequences}
}
\value{
an alphabet of type Alphabet
}
\description{
returns the alphabet which fits to the given sequences
}
\examples{
alphabet = getAlphabetFromSequences("AACCGGTT")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromAlignmentFile}
\alias{getPwmFromAlignmentFile}
\title{generates a pwm from an alignment file}
\usage{
getPwmFromAlignmentFile(filename, alphabet = NULL)
}
\arguments{
\item{filename}{the alignment file}

\item{alphabet}{the desired alphabet of type Alphabet}
}
\value{
a pwm
}
\description{
generates a pwm from an alignment file
}
\examples{
fileName = "extdata/alignments/calamodulin_1.txt"
file = system.file(fileName, package = "DiffLogo")
pwm = getPwmFromAlignmentFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alphabet.R
\name{Alphabet}
\alias{Alphabet}
\title{built alphabet}
\usage{
Alphabet(chars, cols, supportReverseComplement)
}
\arguments{
\item{chars}{set of symbols}

\item{cols}{set of colors; one for each symbol}

\item{supportReverseComplement}{boolean whether the alphabet supports reverse complementation (like DNA/RNA) or not (like ASN)}
}
\value{
the Alphabet object
}
\description{
builts an object of class Alphabet from the given set of symbols and colors
}
\examples{
DNA = Alphabet(c("A","C","G","T"),c("green4","blue","orange","red"),TRUE)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromPwmFile}
\alias{getPwmFromPwmFile}
\title{generates a pwm from a pwm file}
\usage{
getPwmFromPwmFile(filename)
}
\arguments{
\item{filename}{the pwm file}
}
\value{
a pwm
}
\description{
generates a pwm from a pwm file
}
\examples{
fileName = "extdata/pwm/H1-hESC.pwm"
file = system.file(fileName, package = "DiffLogo")
pwm = getPwmFromPwmFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getSequencesFromFastaFile}
\alias{getSequencesFromFastaFile}
\title{extracts the sequences from a FASTA file}
\usage{
getSequencesFromFastaFile(filename)
}
\arguments{
\item{filename}{the FASTA file}
}
\value{
a vector of sequences
}
\description{
extracts the sequences from a FASTA file
}
\examples{
fileName = "extdata/alignments/F-box_bacteria.seq.fa"
file = system.file(fileName, package = "DiffLogo")
sequences = getSequencesFromFastaFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromFastaFile}
\alias{getPwmFromFastaFile}
\title{generates a pwm from a FASTA file}
\usage{
getPwmFromFastaFile(filename, alphabet = NULL)
}
\arguments{
\item{filename}{the FASTA file}

\item{alphabet}{the desired alphabet of type Alphabet}
}
\value{
a pwm
}
\description{
generates a pwm from a FASTA file
}
\examples{
fileName = "extdata/alignments/F-box_bacteria.seq.fa"
file = system.file(fileName, package = "DiffLogo")
pwm = getPwmFromFastaFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogo.R
\name{diffLogoTable}
\alias{diffLogoTable}
\title{Draw DiffLogo-table}
\usage{
diffLogoTable(PWMs, sampleSizes = NULL, alphabet = DNA,
  configuration = list(), ...)
}
\arguments{
\item{PWMs}{a list/vector of position weight matrices (PWMs) each of type pwm, data.frame, or matrix}

\item{sampleSizes}{the number of sequences behind each PWM}

\item{alphabet}{the alphabet of the given PWMs}

\item{configuration}{list of (probably part of) of configuration options. See diffLogoTableConfiguration.}

\item{...}{set of parameters passed to the function 'axis' for plotting}
}
\value{
none (draws table of difference logos)
}
\description{
Draws a table of DiffLogos.
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

diffLogoTable(motifs)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{pwmsDistanceMatrix}
\alias{pwmsDistanceMatrix}
\title{Multiple PWMs alignment}
\usage{
pwmsDistanceMatrix(pwms, diagonal_value = 0,
  bottom_default_value = NULL, divergence = shannonDivergence,
  unaligned_penalty = divergencePenaltyForUnaligned,
  try_reverse_complement = TRUE, base_distribution = NULL,
  length_normalization = FALSE)
}
\arguments{
\item{pwms}{list of pwms}

\item{diagonal_value}{value to put on diagonal.}

\item{bottom_default_value}{value to put on bottom triangle. Set to NULL to get symmetric distance matrix.}

\item{divergence}{divergence measure.}

\item{unaligned_penalty}{is a function for localPwmAlignment.}

\item{try_reverse_complement}{if True, alignment will try reverse complement pwms}

\item{base_distribution}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}

\item{length_normalization}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}
}
\value{
list
}
\description{
Creates a distance matrix for pwms
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogo.R
\name{createDiffLogoObject}
\alias{createDiffLogoObject}
\title{DiffLogo object}
\usage{
createDiffLogoObject(pwm1, pwm2, stackHeight = shannonDivergence,
  baseDistribution = normalizedDifferenceOfProbabilities,
  alphabet = DNA, align_pwms = FALSE,
  unaligned_penalty = divergencePenaltyForUnaligned,
  try_reverse_complement = TRUE, base_distribution = NULL,
  length_normalization = FALSE, unaligned_from_left = 0,
  unaligned_from_right = 0)
}
\arguments{
\item{pwm1}{representation of the first position weight matrix (PWM) of type pwm, data.frame, or matrix}

\item{pwm2}{representation of the second position weight matrix (PWM) of type pwm, data.frame, or matrix}

\item{stackHeight}{function for the height of a stack at position i}

\item{baseDistribution}{function for the heights of the individual bases}

\item{alphabet}{of type Alphabet}

\item{align_pwms}{if True, will aling and extend pwms.}

\item{unaligned_penalty}{is a function for localPwmAlignment.}

\item{try_reverse_complement}{if True, alignment will try reverse complement pwms}

\item{base_distribution}{is a vector of length nrow(pwm) that is added to unaligned columns of pwms for comparing. If NULL, uniform distribution is used}

\item{length_normalization}{If true, will minimize the average divergence between PWMs. Otherwise will minimize the sum of divergences between positions. In both cases unalignes positions are compared to base_distribution and are counted when computing the alignment length.}

\item{unaligned_from_left}{the number of unaligned positions on the left}

\item{unaligned_from_right}{the number of unaligned positions on the right}
}
\value{
DiffLogo object
}
\description{
Creates a DiffLogo object
}
\examples{
motif_folder= "extdata/pwm"
motif_names = c("HepG2","MCF7","HUVEC","ProgFib")
motifs = list()
for (name in motif_names) {
  fileName = paste(motif_folder,"/",name,".pwm",sep="")
  file = system.file(fileName, package = "DiffLogo")
  motifs[[name]] = getPwmFromPwmFile(file)
}

pwm1 = motifs[[motif_names[[1]]]]
pwm2 = motifs[[motif_names[[2]]]]

diffLogoObj = createDiffLogoObject(pwm1 = pwm1, pwm2 = pwm2)
diffLogo(diffLogoObj)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getAlphabetFromCharacters}
\alias{getAlphabetFromCharacters}
\title{returns the alphabet which fits to the given characters}
\usage{
getAlphabetFromCharacters(characters)
}
\arguments{
\item{characters}{a character vector of characters}
}
\value{
an alphabet of type Alphabet
}
\description{
returns the alphabet which fits to the given characters
}
\examples{
alphabet = getAlphabetFromSequences(c("A","A","C","C","G","G","T","T"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogoSupport.R
\name{baseDistributionPwm}
\alias{baseDistributionPwm}
\title{Generates a PWM}
\usage{
baseDistributionPwm(pwm_length, alphabet_length,
  base_distribution = NULL)
}
\arguments{
\item{pwm_length}{the number of positions}

\item{alphabet_length}{the alphabet size}

\item{base_distribution}{optional base distribution for each PWM position}
}
\value{
a PWM
}
\description{
Generates a PWM consisting of only the uniform distribution or the given base_distribution (if defined).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromFile}
\alias{getPwmFromFile}
\title{generates a pwm from a file of different formats}
\usage{
getPwmFromFile(filename)
}
\arguments{
\item{filename}{the file}
}
\value{
a pwm
}
\description{
Generates a pwm from a file of different formats. 
Supported formats are FASTA files (.fa, .fasta), alignment files (.txt, .text, .al, .alignment), PWM files (.pwm), JASPAR / Position Frequency Matrix files (.pfm), and homer files (.motif).
}
\examples{
fileName = "extdata/pwm/H1-hESC.pwm"
file = system.file(fileName, package = "DiffLogo")
pwm = getPwmFromFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromPfmOrJasparFile}
\alias{getPwmFromPfmOrJasparFile}
\title{generates a pwm from a jaspar file}
\usage{
getPwmFromPfmOrJasparFile(filename)
}
\arguments{
\item{filename}{the jaspar file}
}
\value{
a pwm
}
\description{
generates a pwm from a jaspar file
}
\examples{
fileName = "extdata/pfm/ctcf_jaspar.pfm"
file = system.file(fileName, package = "DiffLogo")
pwm = getPwmFromPfmOrJasparFile(file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSeqLogoSupport.R
\name{diffLogoTableConfiguration}
\alias{diffLogoTableConfiguration}
\title{Configuration object for diffLogoTable}
\usage{
diffLogoTableConfiguration(alphabet, stackHeight = shannonDivergence,
  baseDistribution = normalizedDifferenceOfProbabilities,
  uniformYaxis = TRUE, sparse = TRUE, showSequenceLogosTop = TRUE,
  enableClustering = TRUE, treeHeight = 0.5, margin = 0.02,
  ratio = 1, align_pwms = FALSE, multiple_align_pwms = TRUE,
  unaligned_penalty = divergencePenaltyForUnaligned,
  try_reverse_complement = TRUE, length_normalization = FALSE,
  numberOfPermutations = 100)
}
\arguments{
\item{alphabet}{used alphabet of type Alphabet}

\item{stackHeight}{function for the height of a stack at position i}

\item{baseDistribution}{function for the heights of the individual bases}

\item{uniformYaxis}{if TRUE each DiffLogo is plotted with the same scaling of the y-axis}

\item{sparse}{if TRUE margins are reduced and tickmarks are removed from the logo}

\item{showSequenceLogosTop}{if TRUE the classical sequence logos are drawn above each column of the table}

\item{enableClustering}{if TRUE the motifs are reordered, so that similar motifs have a small vertical and horizontal distance in the table}

\item{treeHeight}{the height of the plotted cluster tree above the columns of the table; set equal to zero to omit the cluster tree}

\item{margin}{the space reseverved for labels}

\item{ratio}{the ratio of the plot; this is needed to determine the margin sizes correctly}

\item{align_pwms}{if True, will align and extend pwms in each cell of diffLogoTable independently.}

\item{multiple_align_pwms}{if True, will align and extend pwms in the diffLogoTable jointly.}

\item{unaligned_penalty}{is a function for localPwmAlignment.}

\item{try_reverse_complement}{if True, alignment will try reverse complement pwms}

\item{length_normalization}{if True, divergence between pwms is divided by length of pwms.}

\item{numberOfPermutations}{number of permutations for the permutation test for the calculation of p-values}
}
\value{
list of parameters
}
\description{
Default configuration list for diffLogoTable
}
\examples{
diffLogoTableConfiguration(DNA)
}
\author{
Lando Andrey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alphabet.R
\docType{data}
\name{FULL_ALPHABET}
\alias{FULL_ALPHABET}
\title{Complete character alphabet}
\format{An object of class \code{Alphabet} of length 4.}
\usage{
FULL_ALPHABET
}
\description{
the alphabet of all 26 characters
}
\examples{
FULL_ALPHABET
}
\author{
Hendrik Treutler
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromAlignment}
\alias{getPwmFromAlignment}
\title{Create PWM from alignment}
\usage{
getPwmFromAlignment(alignment, alphabet = NULL, pseudoCount = 0)
}
\arguments{
\item{alignment}{a vector or list of sequences each with equal length}

\item{alphabet}{of type Alphabet}

\item{pseudoCount}{the number of pseudo-observations for each character in the alphabet}
}
\value{
PWM as matrix
}
\description{
Creates a matrix-representation of a PWM from a set of sequences
}
\examples{
motif_folder= "extdata/alignments"
motif_name = "calamodulin_1"
fileName = paste(motif_folder,"/",motif_name,".txt",sep="")
file = system.file(fileName, package = "DiffLogo")
motif = getPwmFromAlignment(readLines(file), ASN, 1)
seqLogo(pwm = motif, alphabet=ASN)
}
\author{
Hendrik Treutler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqLogo.R
\name{seqLogo}
\alias{seqLogo}
\title{Draw sequence logo}
\usage{
seqLogo(pwm, sparse = FALSE, drawLines = 0.5,
  stackHeight = informationContent, baseDistribution = probabilities,
  alphabet = DNA, main = NULL)
}
\arguments{
\item{pwm}{representation of a position weight matrix (PWM) of type pwm, data.frame, or matrix}

\item{sparse}{if TRUE margins are reduced and tickmarks are removed from the logo}

\item{drawLines}{distance between background lines}

\item{stackHeight}{function for the height of a stack at position i}

\item{baseDistribution}{function for the heights of the individual bases}

\item{alphabet}{of type Alphabet}

\item{main}{the main title for the plot}
}
\value{
none (draws sequence logo)
}
\description{
Draws the classic sequence logo.
}
\examples{
motif_folder= "extdata/pwm"
motif_name = "HepG2"
fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
file = system.file(fileName, package = "DiffLogo")
motif = getPwmFromPwmFile(file)
seqLogo(pwm = motif)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmAlignment.R
\name{switchDirection}
\alias{switchDirection}
\title{Switches between 'forward' and 'reverse'}
\usage{
switchDirection(direction)
}
\arguments{
\item{direction}{either 'forward' or 'reverse'}
}
\value{
either 'reverse' or 'forward'
}
\description{
Switches between 'forward' and 'reverse'
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stackHeights.R
\name{sumProbabilities}
\alias{sumProbabilities}
\title{sum of probabilities, i.e. 1.0}
\usage{
sumProbabilities(p)
}
\arguments{
\item{p}{probability vector representing the symbol distribution}
}
\value{
an object consisting of height and ylab
}
\description{
the sum of probabilities for the given probability vector, i.e. 1.0
}
\examples{
motif_folder= "extdata/pwm"
motif_name = "HepG2"
fileName = paste(motif_folder,"/",motif_name,".pwm",sep="")
file = system.file(fileName, package = "DiffLogo")
motif = getPwmFromPwmFile(file)
seqLogo(pwm = motif, stackHeight = sumProbabilities)
}
\author{
Martin Nettling
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getPwmFromHomerFile}
\alias{getPwmFromHomerFile}
\title{generates a pwm from a homer file}
\usage{
getPwmFromHomerFile(filename)
}
\arguments{
\item{filename}{the homer file}
}
\value{
a pwm
}
\description{
generates a pwm from a homer file
}
\examples{
fileName = "extdata/homer/CTCF_Zf_CD4.motif"
file = system.file(fileName, package = "DiffLogo")
pwm = getPwmFromHomerFile(file)
}
